class
	S_SDL_SDL_AUDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	sdl_lock_audio
		external
			"C blocking inline use <sdl_mixer.h>"
		alias
			"SDL_LockAudio();"
		end

	sdl_unlock_audio
		external
			"C blocking inline use <sdl_mixer.h>"
		alias
			"SDL_UnlockAudio();"
		end

	sdl_open_audio (a_desired, a_obtained: CE_POINTER [SD_SDL_AUDIOSPEC]): INTEGER_32
		do
			Result := c_sdl_open_audio (a_desired.c_pointer, a_obtained.c_pointer)
		end

	c_sdl_open_audio (a_desired: POINTER; a_obtained: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return SDL_OpenAudio($a_desired, $a_obtained);"
		end

	sdl_pause_audio (a_pause_on: INTEGER_32)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SDL_PauseAudio($a_pause_on);"
		end

	sdl_load_wav_rw (a_src: CE_POINTER [SD_SDL_RWOPS]; a_freesrc: INTEGER_32; a_spec: CE_POINTER [SD_SDL_AUDIOSPEC]; a_audio_buf: CE_POINTER [CE_POINTER [NATURAL_8]]; a_audio_len: CE_POINTER [NATURAL_32]): CE_POINTER [SD_SDL_AUDIOSPEC]
		do
			create {CE_CLASS_POINTER [SD_SDL_AUDIOSPEC]} Result.make_shared (c_sdl_load_wav_rw (a_src.c_pointer, a_freesrc, a_spec.c_pointer, a_audio_buf.c_pointer, a_audio_len.c_pointer))
		end

	c_sdl_load_wav_rw (a_src: POINTER; a_freesrc: INTEGER_32; a_spec: POINTER; a_audio_buf: POINTER; a_audio_len: POINTER): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)SDL_LoadWAV_RW($a_src, $a_freesrc, $a_spec, $a_audio_buf, $a_audio_len);"
		end

	sdl_build_audio_cvt (a_cvt: CE_POINTER [SD_SDL_AUDIOCVT]; a_src_format: NATURAL_16; a_src_channels: NATURAL_8; a_src_rate: INTEGER_32; a_dst_format: NATURAL_16; a_dst_channels: NATURAL_8; a_dst_rate: INTEGER_32): INTEGER_32
		do
			Result := c_sdl_build_audio_cvt (a_cvt.c_pointer, a_src_format, a_src_channels, a_src_rate, a_dst_format, a_dst_channels, a_dst_rate)
		end

	c_sdl_build_audio_cvt (a_cvt: POINTER; a_src_format: NATURAL_16; a_src_channels: NATURAL_8; a_src_rate: INTEGER_32; a_dst_format: NATURAL_16; a_dst_channels: NATURAL_8; a_dst_rate: INTEGER_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return SDL_BuildAudioCVT($a_cvt, $a_src_format, $a_src_channels, $a_src_rate, $a_dst_format, $a_dst_channels, $a_dst_rate);"
		end

	sdl_convert_audio (a_cvt: CE_POINTER [SD_SDL_AUDIOCVT]): INTEGER_32
		do
			Result := c_sdl_convert_audio (a_cvt.c_pointer)
		end

	c_sdl_convert_audio (a_cvt: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return SDL_ConvertAudio($a_cvt);"
		end

	sdl_mix_audio (a_dst, a_src: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_volume: INTEGER_32)
		do
			c_sdl_mix_audio (a_dst.c_pointer, a_src.c_pointer, a_len, a_volume)
		end

	c_sdl_mix_audio (a_dst: POINTER; a_src: POINTER; a_len: NATURAL_32; a_volume: INTEGER_32)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SDL_MixAudio($a_dst, $a_src, $a_len, $a_volume);"
		end

	sdl_close_audio
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SDL_CloseAudio();"
		end

end
