class
	S_STDLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	strtod (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): REAL_64
		do
			Result := c_strtod (a_nptr.c_pointer, a_endptr.c_pointer)
		end

	c_strtod (a_nptr: POINTER; a_endptr: POINTER): REAL_64
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strtod($a_nptr, $a_endptr);"
		end

	strtol (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): INTEGER_32
		do
			Result := c_strtol (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtol (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strtol($a_nptr, $a_endptr, $a_base);"
		end

	strtoll (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): INTEGER_64
		do
			Result := c_strtoll (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtoll (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): INTEGER_64
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strtoll($a_nptr, $a_endptr, $a_base);"
		end

	atof (a_nptr: CE_POINTER [INTEGER_8]): REAL_64
		do
			Result := (strtod (a_nptr, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)))
		end

	atoi (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := (strtol (a_nptr, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)).to_integer_32
		end

	atol (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := (strtol (a_nptr, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10))
		end

	atoll (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_64
		do
			Result := (strtoll (a_nptr, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10))
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a_ptr: CE_POINTER [ANY])
		do
			c_free (a_ptr.c_pointer)
		end

	c_free (a_ptr: POINTER)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"free($a_ptr);"
		end

	abs (a_x: INTEGER_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return abs($a_x);"
		end

	getenv (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_getenv (a_name.c_pointer))
		end

	c_getenv (a_name: POINTER): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)getenv($a_name);"
		end

	calloc (a_nmemb: NATURAL_32; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_calloc (a_nmemb.to_integer_32, a_size.to_integer_32),
					(a_nmemb * a_size).to_integer_32
				)
		end

end
