class
	SD_SDL_RWOPS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_seek: CE_ROUTINE
				a_read: CE_ROUTINE
				a_write: CE_ROUTINE
				a_close: CE_ROUTINE
				a_type: NATURAL_32
				a_hidden: SD_HIDDEN
			])
		require else
			a_data /= Void
		do
			make
			Current.seek := a_data.a_seek
			Current.read := a_data.a_read
			Current.write := a_data.a_write
			Current.close := a_data.a_close
			Current.type := a_data.a_type
			hidden.c_pointer.memory_copy (a_data.a_hidden.c_pointer, a_data.a_hidden.structure_size)
		end

feature {ANY} -- fields

	seek: CE_ROUTINE assign set_seek
		do
			create Result.make_shared (c__seek (internal_c_pointer))
		end

	read: CE_ROUTINE assign set_read
		do
			create Result.make_shared (c__read (internal_c_pointer))
		end

	write: CE_ROUTINE assign set_write
		do
			create Result.make_shared (c__write (internal_c_pointer))
		end

	close: CE_ROUTINE assign set_close
		do
			create Result.make_shared (c__close (internal_c_pointer))
		end

	type: NATURAL_32 assign set_type
		do
			Result := c__type (internal_c_pointer)
		end

	hidden: SD_HIDDEN
		once ("OBJECT")
			create Result.make_shared (c__hidden (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_seek (a_seek: CE_ROUTINE)
		do
			c__set_seek (internal_c_pointer, a_seek.c_pointer)
		end

	set_read (a_read: CE_ROUTINE)
		do
			c__set_read (internal_c_pointer, a_read.c_pointer)
		end

	set_write (a_write: CE_ROUTINE)
		do
			c__set_write (internal_c_pointer, a_write.c_pointer)
		end

	set_close (a_close: CE_ROUTINE)
		do
			c__set_close (internal_c_pointer, a_close.c_pointer)
		end

	set_type (a_type: NATURAL_32)
		do
			c__set_type (internal_c_pointer, a_type)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct SDL_RWops);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct SDL_RWops);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__seek (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_RWops *)$a_c_pointer)->seek;"
		end

	c__read (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_RWops *)$a_c_pointer)->read;"
		end

	c__write (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_RWops *)$a_c_pointer)->write;"
		end

	c__close (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_RWops *)$a_c_pointer)->close;"
		end

	c__type (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_RWops *)$a_c_pointer)->type;"
		end

	c__hidden (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)&((struct SDL_RWops *)$a_c_pointer)->hidden;"
		end

	c__set_seek (a_c_pointer: POINTER; a_seek: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_RWops *)$a_c_pointer)->seek = $a_seek;"
		end

	c__set_read (a_c_pointer: POINTER; a_read: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_RWops *)$a_c_pointer)->read = $a_read;"
		end

	c__set_write (a_c_pointer: POINTER; a_write: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_RWops *)$a_c_pointer)->write = $a_write;"
		end

	c__set_close (a_c_pointer: POINTER; a_close: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_RWops *)$a_c_pointer)->close = $a_close;"
		end

	c__set_type (a_c_pointer: POINTER; a_type: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_RWops *)$a_c_pointer)->type = $a_type;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "seek") == 0) return offsetof(struct SDL_RWops, seek);
				if(strcmp($a_field_name, "read") == 0) return offsetof(struct SDL_RWops, read);
				if(strcmp($a_field_name, "write") == 0) return offsetof(struct SDL_RWops, write);
				if(strcmp($a_field_name, "close") == 0) return offsetof(struct SDL_RWops, close);
				if(strcmp($a_field_name, "type") == 0) return offsetof(struct SDL_RWops, type);
				if(strcmp($a_field_name, "hidden") == 0) return offsetof(struct SDL_RWops, hidden);
				fprintf(stderr, "struct SDL_RWops.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
