class
	P_EFFECT_POSITION_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_SDL_SDL_ENDIAN_STATIC
	S_STRING_STATIC
	S_SDL_SDL_ERROR_STATIC
	S_SDL_SDL_AUDIO_STATIC

feature {ANY} -- public attributes

	pos_args_array: CE_STATIC [CE_POINTER [CE_POINTER [PD_EFF_POSITIONARGS]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
		end

	pos_args_global: CE_STATIC [CE_POINTER [PD_EFF_POSITIONARGS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
		end

	position_channels: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	speaker_amplitude: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<6>>)
		end

feature {ANY} -- public routines

	eff_position_deinit
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < position_channels.item)
			loop
				free (create {CE_VOID_POINTER}.make_cast (pos_args_array.item[l_i]))
				l_i := l_i + 1
			end
			position_channels.item := 0
			free (create {CE_VOID_POINTER}.make_cast (pos_args_global.item))
			pos_args_global.item := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
			free (create {CE_VOID_POINTER}.make_cast (pos_args_array.item))
			pos_args_array.item := create {CE_POINTER_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
		end

	eff_position_done (a_channel: INTEGER_32; a_udata: CE_POINTER [ANY])
		do
			if a_channel < 0 then
				if not pos_args_global.item.is_void then
					free (create {CE_VOID_POINTER}.make_cast (pos_args_global.item))
					pos_args_global.item := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
				end
			elseif not (pos_args_array.item[a_channel]).is_void then
				free (create {CE_VOID_POINTER}.make_cast (pos_args_array.item[a_channel]))
				pos_args_array.item[a_channel] := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
			end
		end

	eff_position_u8 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
		do
			l_len := a_len
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (a_stream)
			if l_len.to_natural_32 \\ {PLATFORM}.Natural_16_bytes.to_natural_32 /= {NATURAL_32} 0 then
				l_ptr.item := ((l_ptr.item).to_real_32 * l_args.item.distance_f).truncated_to_integer_64.to_natural_8
				l_ptr := l_ptr + 1
				l_len := l_len - 1
			end
			if (l_args.item.room_angle).to_integer_32 = 180 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
				end
			else
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
				end
			end
		end

	eff_position_u8_c4 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
		do
			l_len := a_len
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (a_stream)
			if l_len.to_natural_32 \\ {PLATFORM}.Natural_16_bytes.to_natural_32 /= {NATURAL_32} 0 then
				l_ptr.item := ((l_ptr.item).to_real_32 * l_args.item.distance_f).truncated_to_integer_64.to_natural_8
				l_ptr := l_ptr + 1
				l_len := l_len - 1
			end
			if (l_args.item.room_angle).to_integer_32 = 0 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			elseif (l_args.item.room_angle).to_integer_32 = 90 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			elseif (l_args.item.room_angle).to_integer_32 = 180 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			elseif (l_args.item.room_angle).to_integer_32 = 270 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			end
		end

	eff_position_u8_c6 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
		do
			l_len := a_len
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (a_stream)
			if l_len.to_natural_32 \\ {PLATFORM}.Natural_16_bytes.to_natural_32 /= {NATURAL_32} 0 then
				l_ptr.item := ((l_ptr.item).to_real_32 * l_args.item.distance_f).truncated_to_integer_64.to_natural_8
				l_ptr := l_ptr + 1
				l_len := l_len - 1
			end
			if (l_args.item.room_angle).to_integer_32 = 0 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.center_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			elseif (l_args.item.room_angle).to_integer_32 = 90 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := ((((((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8).to_integer_32 + (((((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8).to_integer_32).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			elseif (l_args.item.room_angle).to_integer_32 = 180 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := ((((((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8).to_integer_32 + (((((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8).to_integer_32).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			elseif (l_args.item.room_angle).to_integer_32 = 270 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := ((((((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8).to_integer_32 + (((((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.left_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8).to_integer_32).to_natural_8
					l_ptr := l_ptr + 1
					l_ptr.item := (((((((l_ptr.item).to_integer_32 - 128).to_integer_8).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8).to_integer_32 + 128).to_natural_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
				end
			end
		end

	eff_position_table_u8 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_l: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_temp: CE_POINTER [NATURAL_8]
		do
			l_len := a_len
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (a_stream)
			l_l := create {CE_NATURAL_8_POINTER}.make_cast ((create {P_EFFECTS_INTERNAL_STATIC}).eff_volume_table.item) + 256 * (l_args.item.left_u8).to_integer_32
			l_r := create {CE_NATURAL_8_POINTER}.make_cast ((create {P_EFFECTS_INTERNAL_STATIC}).eff_volume_table.item) + 256 * (l_args.item.right_u8).to_integer_32
			l_d := create {CE_NATURAL_8_POINTER}.make_cast ((create {P_EFFECTS_INTERNAL_STATIC}).eff_volume_table.item) + 256 * (l_args.item.distance_u8).to_integer_32
			if (l_args.item.room_angle).to_integer_32 = 180 then
				l_temp := l_l
				l_l := l_r
				l_r := l_temp
			end
			from
			until
				l_len.to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32 = {NATURAL_32} 0
			loop
				l_ptr.item := l_d[(l_l[(l_ptr.item).to_integer_32]).to_integer_32]
				l_ptr := l_ptr + 1
				if l_args.item.channels > 1 then
					l_ptr.item := l_d[(l_r[(l_ptr.item).to_integer_32]).to_integer_32]
					l_ptr := l_ptr + 1
				end
				l_len := l_len - (l_args.item.channels)
			end
			l_p := create {CE_NATURAL_32_POINTER}.make_cast (l_ptr)
			l_i := 0
			from
			until
				not (l_i < l_len)
			loop
				l_p.item := (((((((((l_d[(l_r[((((l_p.item).bit_and ({NATURAL_32} 4_278_190_080))).bit_shift_right (24)).to_integer_32]).to_integer_32]).to_integer_32).bit_shift_left (24))).bit_or ((((l_d[(l_l[((((l_p.item).bit_and ({NATURAL_32} 16_711_680))).bit_shift_right (16)).to_integer_32]).to_integer_32]).to_integer_32).bit_shift_left (16))))).bit_or ((((l_d[(l_r[((((l_p.item).bit_and ({NATURAL_32} 65_280))).bit_shift_right (8)).to_integer_32]).to_integer_32]).to_integer_32).bit_shift_left (8))))).bit_or ((l_d[(l_l[((l_p.item).bit_and ({NATURAL_32} 255)).to_integer_32]).to_integer_32]).to_integer_32)).to_natural_32
				l_p := l_p + 1
				l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
			end
		end

	eff_position_s8 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
		do
			l_len := a_len
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_INTEGER_8_POINTER}.make_cast (a_stream)
			if l_len.to_natural_32 \\ {PLATFORM}.Integer_16_bytes.to_natural_32 /= {NATURAL_32} 0 then
				l_ptr[0] := ((l_ptr[0]).to_real * l_args.item.distance_f).truncated_to_integer.to_integer_8
				l_ptr := l_ptr + 1
				l_len := l_len - 1
			end
			if (l_args.item.room_angle).to_integer_32 = 180 then
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
					l_ptr := l_ptr + 1
					l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
				end
			else
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
					l_ptr := l_ptr + 1
					l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
					l_ptr := l_ptr + 1
					l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
				end
			end
		end

	eff_position_s8_c4 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_INTEGER_8_POINTER}.make_cast (a_stream)
					if l_len.to_natural_32 \\ {PLATFORM}.Integer_16_bytes.to_natural_32 /= {NATURAL_32} 0 then
						l_ptr[0] := ((l_ptr[0]).to_real * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_len := l_len - 1
					end
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < l_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 4).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_s8_c6 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_INTEGER_8_POINTER}.make_cast (a_stream)
					if l_len.to_natural_32 \\ {PLATFORM}.Integer_16_bytes.to_natural_32 /= {NATURAL_32} 0 then
						l_ptr[0] := ((l_ptr[0]).to_real * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_len := l_len - 1
					end
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < l_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.center_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := ((((((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + (((((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32).to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := ((((((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + (((((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32).to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := ((((((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32 + (((((l_ptr[0]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f) / (2).to_real).truncated_to_integer.to_integer_8).to_integer_32).to_integer_8
						l_ptr := l_ptr + 1
						l_ptr[0] := (((l_ptr[0]).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_8
						l_ptr := l_ptr + 1
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_table_s8 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_l: CE_POINTER [INTEGER_8]
			l_r: CE_POINTER [INTEGER_8]
			l_d: CE_POINTER [INTEGER_8]
			l_temp: CE_POINTER [INTEGER_8]
		do
			l_len := a_len
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_INTEGER_8_POINTER}.make_cast (a_stream)
			l_l := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EFFECTS_INTERNAL_STATIC}).eff_volume_table.item) + 256 * (l_args.item.left_u8).to_integer_32
			l_r := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EFFECTS_INTERNAL_STATIC}).eff_volume_table.item) + 256 * (l_args.item.right_u8).to_integer_32
			l_d := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EFFECTS_INTERNAL_STATIC}).eff_volume_table.item) + 256 * (l_args.item.distance_u8).to_integer_32
			if (l_args.item.room_angle).to_integer_32 = 180 then
				l_temp := l_l
				l_l := l_r
				l_r := l_temp
			end
			from
			until
				l_len.to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32 = {NATURAL_32} 0
			loop
				l_ptr[0] := l_d[(l_l[(l_ptr[0]).to_integer_32]).to_integer_32]
				l_ptr := l_ptr + 1
				if l_args.item.channels > 1 then
					l_ptr[0] := l_d[(l_r[(l_ptr[0]).to_integer_32]).to_integer_32]
					l_ptr := l_ptr + 1
				end
				l_len := l_len - (l_args.item.channels)
			end
			l_p := create {CE_NATURAL_32_POINTER}.make_cast (l_ptr)
			l_i := 0
			from
			until
				not (l_i < l_len)
			loop
				l_p.item := (((((((((l_d[(l_r[(((((((l_p.item).bit_and ({NATURAL_32} 4_278_190_080))).bit_shift_right (24)).to_integer_8).to_integer_16).to_integer_32 + 128)]).to_integer_32]).to_integer_32).bit_shift_left (24))).bit_or ((((l_d[(l_l[(((((((l_p.item).bit_and ({NATURAL_32} 16_711_680))).bit_shift_right (16)).to_integer_8).to_integer_16).to_integer_32 + 128)]).to_integer_32]).to_integer_32).bit_shift_left (16))))).bit_or ((((l_d[(l_r[(((((((l_p.item).bit_and ({NATURAL_32} 65_280))).bit_shift_right (8)).to_integer_8).to_integer_16).to_integer_32 + 128)]).to_integer_32]).to_integer_32).bit_shift_left (8))))).bit_or ((l_d[(l_l[(((((l_p.item).bit_and ({NATURAL_32} 255)).to_integer_8).to_integer_16).to_integer_32 + 128)]).to_integer_32]).to_integer_32)).to_natural_32
				l_p := l_p + 1
				l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
			end
		end

	eff_position_u16lsb (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_16]
			l_i: INTEGER_32
			l_sampl: INTEGER_16
			l_sampr: INTEGER_16
			l_swapl: NATURAL_16
			l_swapr: NATURAL_16
			l_tmp: CE_POINTER [NATURAL_16]
			l_tmp_0: CE_POINTER [NATURAL_16]
			l_tmp_1: CE_POINTER [NATURAL_16]
			l_tmp_2: CE_POINTER [NATURAL_16]
		do
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_NATURAL_16_POINTER}.make_cast (a_stream)
			l_i := 0
			from
			until
				not (l_i < a_len)
			loop
				l_sampl := ((l_ptr[0]).to_integer_32 - 32_768).to_integer_16
				l_sampr := ((l_ptr[1]).to_integer_32 - 32_768).to_integer_16
				l_swapl := ((((l_sampl.to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
				l_swapr := ((((l_sampr.to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
				if (l_args.item.room_angle).to_integer_32 = 180 then
					l_tmp := l_ptr
					l_ptr := l_ptr + 1
					l_tmp.item := l_swapr
					l_tmp_0 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_0.item := l_swapl
				else
					l_tmp_1 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_1.item := l_swapl
					l_tmp_2 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_2.item := l_swapr
				end
				l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_16_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
			end
		end

	eff_position_u16lsb_c4 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_16]
			l_i: INTEGER_32
			l_sampl: INTEGER_16
			l_sampr: INTEGER_16
			l_samplr: INTEGER_16
			l_samprr: INTEGER_16
			l_swapl: NATURAL_16
			l_swapr: NATURAL_16
			l_swaplr: NATURAL_16
			l_swaprr: NATURAL_16
			l_tmp: CE_POINTER [NATURAL_16]
			l_tmp_0: CE_POINTER [NATURAL_16]
			l_tmp_1: CE_POINTER [NATURAL_16]
			l_tmp_2: CE_POINTER [NATURAL_16]
			l_tmp_3: CE_POINTER [NATURAL_16]
			l_tmp_4: CE_POINTER [NATURAL_16]
			l_tmp_5: CE_POINTER [NATURAL_16]
			l_tmp_6: CE_POINTER [NATURAL_16]
			l_tmp_7: CE_POINTER [NATURAL_16]
			l_tmp_8: CE_POINTER [NATURAL_16]
			l_tmp_9: CE_POINTER [NATURAL_16]
			l_tmp_10: CE_POINTER [NATURAL_16]
			l_tmp_11: CE_POINTER [NATURAL_16]
			l_tmp_12: CE_POINTER [NATURAL_16]
			l_tmp_13: CE_POINTER [NATURAL_16]
			l_tmp_14: CE_POINTER [NATURAL_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_NATURAL_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_sampl := ((l_ptr[0]).to_integer_32 - 32_768).to_integer_16
						l_sampr := ((l_ptr[1]).to_integer_32 - 32_768).to_integer_16
						l_samplr := ((l_ptr[2]).to_integer_32 - 32_768).to_integer_16
						l_samprr := ((l_ptr[3]).to_integer_32 - 32_768).to_integer_16
						l_swapl := ((((l_sampl.to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapr := ((((l_sampr.to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaplr := ((((l_samplr.to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaprr := ((((l_samprr.to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp := l_ptr
						l_ptr := l_ptr + 1
						l_tmp.item := l_swapl
						l_tmp_0 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_0.item := l_swapr
						l_tmp_1 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_1.item := l_swaplr
						l_tmp_2 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_2.item := l_swaprr
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_3.item := l_swapr
						l_tmp_4 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_4.item := l_swaprr
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := l_swapl
						l_tmp_6 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_6.item := l_swaplr
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := l_swaprr
						l_tmp_8 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_8.item := l_swaplr
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := l_swapr
						l_tmp_10 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_10.item := l_swapl
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := l_swaplr
						l_tmp_12 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_12.item := l_swapl
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := l_swaprr
						l_tmp_14 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_14.item := l_swapr
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_16_bytes.to_natural_32 * {NATURAL_32} 4).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_u16lsb_c6 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_16]
			l_i: INTEGER_32
			l_sampl: INTEGER_16
			l_sampr: INTEGER_16
			l_samplr: INTEGER_16
			l_samprr: INTEGER_16
			l_sampce: INTEGER_16
			l_sampwf: INTEGER_16
			l_swapl: NATURAL_16
			l_swapr: NATURAL_16
			l_swaplr: NATURAL_16
			l_swaprr: NATURAL_16
			l_swapce: NATURAL_16
			l_swapwf: NATURAL_16
			l_tmp: CE_POINTER [NATURAL_16]
			l_tmp_0: CE_POINTER [NATURAL_16]
			l_tmp_1: CE_POINTER [NATURAL_16]
			l_tmp_2: CE_POINTER [NATURAL_16]
			l_tmp_3: CE_POINTER [NATURAL_16]
			l_tmp_4: CE_POINTER [NATURAL_16]
			l_tmp_5: CE_POINTER [NATURAL_16]
			l_tmp_6: CE_POINTER [NATURAL_16]
			l_tmp_7: CE_POINTER [NATURAL_16]
			l_tmp_8: CE_POINTER [NATURAL_16]
			l_tmp_9: CE_POINTER [NATURAL_16]
			l_tmp_10: CE_POINTER [NATURAL_16]
			l_tmp_11: CE_POINTER [NATURAL_16]
			l_tmp_12: CE_POINTER [NATURAL_16]
			l_tmp_13: CE_POINTER [NATURAL_16]
			l_tmp_14: CE_POINTER [NATURAL_16]
			l_tmp_15: CE_POINTER [NATURAL_16]
			l_tmp_16: CE_POINTER [NATURAL_16]
			l_tmp_17: CE_POINTER [NATURAL_16]
			l_tmp_18: CE_POINTER [NATURAL_16]
			l_tmp_19: CE_POINTER [NATURAL_16]
			l_tmp_20: CE_POINTER [NATURAL_16]
			l_tmp_21: CE_POINTER [NATURAL_16]
			l_tmp_22: CE_POINTER [NATURAL_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_NATURAL_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_sampl := ((l_ptr[0]).to_integer_32 - 32_768).to_integer_16
						l_sampr := ((l_ptr[1]).to_integer_32 - 32_768).to_integer_16
						l_samplr := ((l_ptr[2]).to_integer_32 - 32_768).to_integer_16
						l_samprr := ((l_ptr[3]).to_integer_32 - 32_768).to_integer_16
						l_sampce := ((l_ptr[4]).to_integer_32 - 32_768).to_integer_16
						l_sampwf := ((l_ptr[5]).to_integer_32 - 32_768).to_integer_16
						l_swapl := ((((l_sampl.to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapr := ((((l_sampr.to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaplr := ((((l_samplr.to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaprr := ((((l_samprr.to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapce := ((((l_sampce.to_real * l_args.item.center_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapwf := ((((l_sampwf.to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp := l_ptr
						l_ptr := l_ptr + 1
						l_tmp.item := l_swapl
						l_tmp_0 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_0.item := l_swapr
						l_tmp_1 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_1.item := l_swaplr
						l_tmp_2 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_2.item := l_swaprr
						l_tmp_3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_3.item := l_swapce
						l_tmp_4 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_4.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := l_swapr
						l_tmp_6 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_6.item := l_swaprr
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := l_swapl
						l_tmp_8 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_8.item := l_swaplr
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := (l_swapr.to_integer_32 // 2 + l_swaprr.to_integer_32 // 2).to_natural_16
						l_tmp_10 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_10.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := l_swaprr
						l_tmp_12 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_12.item := l_swaplr
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := l_swapr
						l_tmp_14 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_14.item := l_swapl
						l_tmp_15 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_15.item := (l_swaprr.to_integer_32 // 2 + l_swaplr.to_integer_32 // 2).to_natural_16
						l_tmp_16 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_16.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_17 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_17.item := l_swaplr
						l_tmp_18 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_18.item := l_swapl
						l_tmp_19 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_19.item := l_swaprr
						l_tmp_20 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_20.item := l_swapr
						l_tmp_21 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_21.item := (l_swapl.to_integer_32 // 2 + l_swaplr.to_integer_32 // 2).to_natural_16
						l_tmp_22 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_22.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_16_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_s16lsb (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_16]
			l_i: INTEGER_32
			l_swapl: INTEGER_16
			l_swapr: INTEGER_16
			l_tmp: CE_POINTER [INTEGER_16]
			l_tmp_0: CE_POINTER [INTEGER_16]
			l_tmp_1: CE_POINTER [INTEGER_16]
			l_tmp_2: CE_POINTER [INTEGER_16]
		do
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_INTEGER_16_POINTER}.make_cast (a_stream)
			l_i := 0
			from
			until
				not (l_i < a_len)
			loop
				l_swapl := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
				l_swapr := (((l_ptr[1]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
				if (l_args.item.room_angle).to_integer_32 = 180 then
					l_tmp := l_ptr
					l_ptr := l_ptr + 1
					l_tmp.item := l_swapr
					l_tmp_0 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_0.item := l_swapl
				else
					l_tmp_1 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_1.item := l_swapl
					l_tmp_2 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_2.item := l_swapr
				end
				l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
			end
		end

	eff_position_s16lsb_c4 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_16]
			l_i: INTEGER_32
			l_swapl: INTEGER_16
			l_swapr: INTEGER_16
			l_swaplr: INTEGER_16
			l_swaprr: INTEGER_16
			l_tmp: CE_POINTER [INTEGER_16]
			l_tmp_0: CE_POINTER [INTEGER_16]
			l_tmp_1: CE_POINTER [INTEGER_16]
			l_tmp_2: CE_POINTER [INTEGER_16]
			l_tmp_3: CE_POINTER [INTEGER_16]
			l_tmp_4: CE_POINTER [INTEGER_16]
			l_tmp_5: CE_POINTER [INTEGER_16]
			l_tmp_6: CE_POINTER [INTEGER_16]
			l_tmp_7: CE_POINTER [INTEGER_16]
			l_tmp_8: CE_POINTER [INTEGER_16]
			l_tmp_9: CE_POINTER [INTEGER_16]
			l_tmp_10: CE_POINTER [INTEGER_16]
			l_tmp_11: CE_POINTER [INTEGER_16]
			l_tmp_12: CE_POINTER [INTEGER_16]
			l_tmp_13: CE_POINTER [INTEGER_16]
			l_tmp_14: CE_POINTER [INTEGER_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_INTEGER_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_swapl := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapr := (((l_ptr[1]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaplr := (((l_ptr[1]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaprr := (((l_ptr[2]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp := l_ptr
						l_ptr := l_ptr + 1
						l_tmp.item := l_swapl
						l_tmp_0 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_0.item := l_swapr
						l_tmp_1 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_1.item := l_swaplr
						l_tmp_2 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_2.item := l_swaprr
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_3.item := l_swapr
						l_tmp_4 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_4.item := l_swaprr
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := l_swapl
						l_tmp_6 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_6.item := l_swaplr
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := l_swaprr
						l_tmp_8 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_8.item := l_swaplr
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := l_swapr
						l_tmp_10 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_10.item := l_swapl
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := l_swaplr
						l_tmp_12 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_12.item := l_swapl
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := l_swaprr
						l_tmp_14 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_14.item := l_swapr
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 4).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_s16lsb_c6 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_16]
			l_i: INTEGER_32
			l_swapl: INTEGER_16
			l_swapr: INTEGER_16
			l_swaplr: INTEGER_16
			l_swaprr: INTEGER_16
			l_swapce: INTEGER_16
			l_swapwf: INTEGER_16
			l_tmp: CE_POINTER [INTEGER_16]
			l_tmp_0: CE_POINTER [INTEGER_16]
			l_tmp_1: CE_POINTER [INTEGER_16]
			l_tmp_2: CE_POINTER [INTEGER_16]
			l_tmp_3: CE_POINTER [INTEGER_16]
			l_tmp_4: CE_POINTER [INTEGER_16]
			l_tmp_5: CE_POINTER [INTEGER_16]
			l_tmp_6: CE_POINTER [INTEGER_16]
			l_tmp_7: CE_POINTER [INTEGER_16]
			l_tmp_8: CE_POINTER [INTEGER_16]
			l_tmp_9: CE_POINTER [INTEGER_16]
			l_tmp_10: CE_POINTER [INTEGER_16]
			l_tmp_11: CE_POINTER [INTEGER_16]
			l_tmp_12: CE_POINTER [INTEGER_16]
			l_tmp_13: CE_POINTER [INTEGER_16]
			l_tmp_14: CE_POINTER [INTEGER_16]
			l_tmp_15: CE_POINTER [INTEGER_16]
			l_tmp_16: CE_POINTER [INTEGER_16]
			l_tmp_17: CE_POINTER [INTEGER_16]
			l_tmp_18: CE_POINTER [INTEGER_16]
			l_tmp_19: CE_POINTER [INTEGER_16]
			l_tmp_20: CE_POINTER [INTEGER_16]
			l_tmp_21: CE_POINTER [INTEGER_16]
			l_tmp_22: CE_POINTER [INTEGER_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_INTEGER_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_swapl := (((l_ptr[0]).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapr := (((l_ptr[1]).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaplr := (((l_ptr[2]).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaprr := (((l_ptr[3]).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapce := (((l_ptr[4]).to_real * l_args.item.center_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapwf := (((l_ptr[5]).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp := l_ptr
						l_ptr := l_ptr + 1
						l_tmp.item := l_swapl
						l_tmp_0 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_0.item := l_swapr
						l_tmp_1 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_1.item := l_swaplr
						l_tmp_2 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_2.item := l_swaprr
						l_tmp_3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_3.item := l_swapce
						l_tmp_4 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_4.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := l_swapr
						l_tmp_6 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_6.item := l_swaprr
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := l_swapl
						l_tmp_8 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_8.item := l_swaplr
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := (l_swapr.to_integer_32 // 2 + l_swaprr.to_integer_32 // 2).to_integer_16
						l_tmp_10 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_10.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := l_swaprr
						l_tmp_12 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_12.item := l_swaplr
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := l_swapr
						l_tmp_14 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_14.item := l_swapl
						l_tmp_15 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_15.item := (l_swaprr.to_integer_32 // 2 + l_swaplr.to_integer_32 // 2).to_integer_16
						l_tmp_16 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_16.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_17 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_17.item := l_swaplr
						l_tmp_18 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_18.item := l_swapl
						l_tmp_19 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_19.item := l_swaprr
						l_tmp_20 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_20.item := l_swapr
						l_tmp_21 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_21.item := (l_swapl.to_integer_32 // 2 + l_swaplr.to_integer_32 // 2).to_integer_16
						l_tmp_22 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_22.item := l_swapwf
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_u16msb (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_16]
			l_i: INTEGER_32
			l_sampl: INTEGER_16
			l_sampr: INTEGER_16
			l_swapl: NATURAL_16
			l_swapr: NATURAL_16
			l_tmp_1: CE_POINTER [NATURAL_16]
			l_tmp_3: CE_POINTER [NATURAL_16]
			l_tmp_5: CE_POINTER [NATURAL_16]
			l_tmp_7: CE_POINTER [NATURAL_16]
		do
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_NATURAL_16_POINTER}.make_cast (a_stream)
			l_i := 0
			from
			until
				not (l_i < a_len)
			loop
				l_sampl := ((sdl_swap16 (l_ptr[0])).to_integer_32 - 32_768).to_integer_16
				l_sampr := ((sdl_swap16 (l_ptr[1])).to_integer_32 - 32_768).to_integer_16
				l_swapl := ((((l_sampl.to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
				l_swapr := ((((l_sampr.to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
				if (l_args.item.room_angle).to_integer_32 = 180 then
					l_tmp_1 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_1.item := (sdl_swap16 (l_swapr))
					l_tmp_3 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_3.item := (sdl_swap16 (l_swapl))
				else
					l_tmp_5 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_5.item := (sdl_swap16 (l_swapl))
					l_tmp_7 := l_ptr
					l_ptr := l_ptr + 1
					l_tmp_7.item := (sdl_swap16 (l_swapr))
				end
				l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
			end
		end

	eff_position_u16msb_c4 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_16]
			l_i: INTEGER_32
			l_sampl: INTEGER_16
			l_sampr: INTEGER_16
			l_samplr: INTEGER_16
			l_samprr: INTEGER_16
			l_swapl: NATURAL_16
			l_swapr: NATURAL_16
			l_swaplr: NATURAL_16
			l_swaprr: NATURAL_16
			l_tmp_3: CE_POINTER [NATURAL_16]
			l_tmp_5: CE_POINTER [NATURAL_16]
			l_tmp_7: CE_POINTER [NATURAL_16]
			l_tmp_9: CE_POINTER [NATURAL_16]
			l_tmp_11: CE_POINTER [NATURAL_16]
			l_tmp_13: CE_POINTER [NATURAL_16]
			l_tmp_15: CE_POINTER [NATURAL_16]
			l_tmp_17: CE_POINTER [NATURAL_16]
			l_tmp_19: CE_POINTER [NATURAL_16]
			l_tmp_21: CE_POINTER [NATURAL_16]
			l_tmp_23: CE_POINTER [NATURAL_16]
			l_tmp_25: CE_POINTER [NATURAL_16]
			l_tmp_27: CE_POINTER [NATURAL_16]
			l_tmp_29: CE_POINTER [NATURAL_16]
			l_tmp_31: CE_POINTER [NATURAL_16]
			l_tmp_33: CE_POINTER [NATURAL_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_NATURAL_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_sampl := ((sdl_swap16 (l_ptr[0])).to_integer_32 - 32_768).to_integer_16
						l_sampr := ((sdl_swap16 (l_ptr[1])).to_integer_32 - 32_768).to_integer_16
						l_samplr := ((sdl_swap16 (l_ptr[2])).to_integer_32 - 32_768).to_integer_16
						l_samprr := ((sdl_swap16 (l_ptr[3])).to_integer_32 - 32_768).to_integer_16
						l_swapl := ((((l_sampl.to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapr := ((((l_sampr.to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaplr := ((((l_samplr.to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaprr := ((((l_samprr.to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp_3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_3.item := (sdl_swap16 (l_swapl))
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := (sdl_swap16 (l_swapr))
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := (sdl_swap16 (l_swaplr))
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := (sdl_swap16 (l_swaprr))
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := (sdl_swap16 (l_swapr))
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := (sdl_swap16 (l_swaprr))
						l_tmp_15 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_15.item := (sdl_swap16 (l_swapl))
						l_tmp_17 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_17.item := (sdl_swap16 (l_swaplr))
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_19 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_19.item := (sdl_swap16 (l_swaprr))
						l_tmp_21 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_21.item := (sdl_swap16 (l_swaplr))
						l_tmp_23 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_23.item := (sdl_swap16 (l_swapr))
						l_tmp_25 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_25.item := (sdl_swap16 (l_swapl))
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_27 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_27.item := (sdl_swap16 (l_swaplr))
						l_tmp_29 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_29.item := (sdl_swap16 (l_swapl))
						l_tmp_31 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_31.item := (sdl_swap16 (l_swaprr))
						l_tmp_33 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_33.item := (sdl_swap16 (l_swapr))
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 4).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_u16msb_c6 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [NATURAL_16]
			l_i: INTEGER_32
			l_sampl: INTEGER_16
			l_sampr: INTEGER_16
			l_samplr: INTEGER_16
			l_samprr: INTEGER_16
			l_sampce: INTEGER_16
			l_sampwf: INTEGER_16
			l_swapl: NATURAL_16
			l_swapr: NATURAL_16
			l_swaplr: NATURAL_16
			l_swaprr: NATURAL_16
			l_swapce: NATURAL_16
			l_swapwf: NATURAL_16
			l_tmp_5: CE_POINTER [NATURAL_16]
			l_tmp_7: CE_POINTER [NATURAL_16]
			l_tmp_9: CE_POINTER [NATURAL_16]
			l_tmp_11: CE_POINTER [NATURAL_16]
			l_tmp_13: CE_POINTER [NATURAL_16]
			l_tmp_15: CE_POINTER [NATURAL_16]
			l_tmp_17: CE_POINTER [NATURAL_16]
			l_tmp_19: CE_POINTER [NATURAL_16]
			l_tmp_21: CE_POINTER [NATURAL_16]
			l_tmp_23: CE_POINTER [NATURAL_16]
			l_tmp_25: CE_POINTER [NATURAL_16]
			l_tmp_26: NATURAL_16
			l_tmp_28: CE_POINTER [NATURAL_16]
			l_tmp_30: CE_POINTER [NATURAL_16]
			l_tmp_32: CE_POINTER [NATURAL_16]
			l_tmp_34: CE_POINTER [NATURAL_16]
			l_tmp_36: CE_POINTER [NATURAL_16]
			l_tmp_38: CE_POINTER [NATURAL_16]
			l_tmp_39: NATURAL_16
			l_tmp_41: CE_POINTER [NATURAL_16]
			l_tmp_43: CE_POINTER [NATURAL_16]
			l_tmp_45: CE_POINTER [NATURAL_16]
			l_tmp_47: CE_POINTER [NATURAL_16]
			l_tmp_49: CE_POINTER [NATURAL_16]
			l_tmp_51: CE_POINTER [NATURAL_16]
			l_tmp_52: NATURAL_16
			l_tmp_54: CE_POINTER [NATURAL_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_NATURAL_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_sampl := ((sdl_swap16 (l_ptr[0])).to_integer_32 - 32_768).to_integer_16
						l_sampr := ((sdl_swap16 (l_ptr[1])).to_integer_32 - 32_768).to_integer_16
						l_samplr := ((sdl_swap16 (l_ptr[2])).to_integer_32 - 32_768).to_integer_16
						l_samprr := ((sdl_swap16 (l_ptr[3])).to_integer_32 - 32_768).to_integer_16
						l_sampce := ((sdl_swap16 (l_ptr[4])).to_integer_32 - 32_768).to_integer_16
						l_sampwf := ((sdl_swap16 (l_ptr[5])).to_integer_32 - 32_768).to_integer_16
						l_swapl := ((((l_sampl.to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapr := ((((l_sampr.to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaplr := ((((l_samplr.to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swaprr := ((((l_samprr.to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapce := ((((l_sampce.to_real * l_args.item.center_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						l_swapwf := ((((l_sampwf.to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16).to_integer_32 + 32_768).to_natural_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := (sdl_swap16 (l_swapl))
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := (sdl_swap16 (l_swapr))
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := (sdl_swap16 (l_swaplr))
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := (sdl_swap16 (l_swaprr))
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := (sdl_swap16 (l_swapce))
						l_tmp_15 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_15.item := (sdl_swap16 (l_swapwf))
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_17 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_17.item := (sdl_swap16 (l_swapr))
						l_tmp_19 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_19.item := (sdl_swap16 (l_swaprr))
						l_tmp_21 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_21.item := (sdl_swap16 (l_swapl))
						l_tmp_23 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_23.item := (sdl_swap16 (l_swaplr))
						l_tmp_25 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_26 := sdl_swap16 (l_swapr)
						l_tmp_25.item := (l_tmp_26.to_integer_32 // 2 + (sdl_swap16 (l_swaprr)).to_integer_32 // 2).to_natural_16
						l_tmp_28 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_28.item := (sdl_swap16 (l_swapwf))
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_30 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_30.item := (sdl_swap16 (l_swaprr))
						l_tmp_32 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_32.item := (sdl_swap16 (l_swaplr))
						l_tmp_34 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_34.item := (sdl_swap16 (l_swapr))
						l_tmp_36 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_36.item := (sdl_swap16 (l_swapl))
						l_tmp_38 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_39 := sdl_swap16 (l_swaprr)
						l_tmp_38.item := (l_tmp_39.to_integer_32 // 2 + (sdl_swap16 (l_swaplr)).to_integer_32 // 2).to_natural_16
						l_tmp_41 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_41.item := (sdl_swap16 (l_swapwf))
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_43 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_43.item := (sdl_swap16 (l_swaplr))
						l_tmp_45 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_45.item := (sdl_swap16 (l_swapl))
						l_tmp_47 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_47.item := (sdl_swap16 (l_swaprr))
						l_tmp_49 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_49.item := (sdl_swap16 (l_swapr))
						l_tmp_51 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_52 := sdl_swap16 (l_swapl)
						l_tmp_51.item := (l_tmp_52.to_integer_32 // 2 + (sdl_swap16 (l_swaplr)).to_integer_32 // 2).to_natural_16
						l_tmp_54 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_54.item := (sdl_swap16 (l_swapwf))
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_s16msb (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_16]
			l_i: INTEGER_32
			l_swapl: INTEGER_16
			l_swapr: INTEGER_16
			l_tmp_1: CE_POINTER [INTEGER_16]
			l_tmp_3: CE_POINTER [INTEGER_16]
		do
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
			l_ptr := create {CE_INTEGER_16_POINTER}.make_cast (a_stream)
			l_i := 0
			from
			until
				not (l_i < a_len)
			loop
				l_swapl := ((((sdl_swap16 ((l_ptr[0]).to_natural_16)).to_integer_16).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
				l_swapr := ((((sdl_swap16 ((l_ptr[1]).to_natural_16)).to_integer_16).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
				l_tmp_1 := l_ptr
				l_ptr := l_ptr + 1
				l_tmp_1.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
				l_tmp_3 := l_ptr
				l_ptr := l_ptr + 1
				l_tmp_3.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
				l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 2).to_integer_32
			end
		end

	eff_position_s16msb_c4 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_16]
			l_i: INTEGER_32
			l_swapl: INTEGER_16
			l_swapr: INTEGER_16
			l_swaplr: INTEGER_16
			l_swaprr: INTEGER_16
			l_tmp_3: CE_POINTER [INTEGER_16]
			l_tmp_5: CE_POINTER [INTEGER_16]
			l_tmp_7: CE_POINTER [INTEGER_16]
			l_tmp_9: CE_POINTER [INTEGER_16]
			l_tmp_11: CE_POINTER [INTEGER_16]
			l_tmp_13: CE_POINTER [INTEGER_16]
			l_tmp_15: CE_POINTER [INTEGER_16]
			l_tmp_17: CE_POINTER [INTEGER_16]
			l_tmp_19: CE_POINTER [INTEGER_16]
			l_tmp_21: CE_POINTER [INTEGER_16]
			l_tmp_23: CE_POINTER [INTEGER_16]
			l_tmp_25: CE_POINTER [INTEGER_16]
			l_tmp_27: CE_POINTER [INTEGER_16]
			l_tmp_29: CE_POINTER [INTEGER_16]
			l_tmp_31: CE_POINTER [INTEGER_16]
			l_tmp_33: CE_POINTER [INTEGER_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_INTEGER_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_swapl := ((((sdl_swap16 ((l_ptr[0]).to_natural_16)).to_integer_16).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapr := ((((sdl_swap16 ((l_ptr[1]).to_natural_16)).to_integer_16).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaplr := ((((sdl_swap16 ((l_ptr[2]).to_natural_16)).to_integer_16).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaprr := ((((sdl_swap16 ((l_ptr[3]).to_natural_16)).to_integer_16).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp_3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_3.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_tmp_15 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_15.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_tmp_17 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_17.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_19 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_19.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_tmp_21 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_21.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_tmp_23 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_23.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_tmp_25 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_25.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_27 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_27.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_tmp_29 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_29.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_tmp_31 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_31.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_tmp_33 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_33.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 4).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eff_position_s16msb_c6 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_ptr: CE_POINTER [INTEGER_16]
			l_i: INTEGER_32
			l_swapl: INTEGER_16
			l_swapr: INTEGER_16
			l_swaplr: INTEGER_16
			l_swaprr: INTEGER_16
			l_swapce: INTEGER_16
			l_swapwf: INTEGER_16
			l_tmp_5: CE_POINTER [INTEGER_16]
			l_tmp_7: CE_POINTER [INTEGER_16]
			l_tmp_9: CE_POINTER [INTEGER_16]
			l_tmp_11: CE_POINTER [INTEGER_16]
			l_tmp_13: CE_POINTER [INTEGER_16]
			l_tmp_15: CE_POINTER [INTEGER_16]
			l_tmp_17: CE_POINTER [INTEGER_16]
			l_tmp_19: CE_POINTER [INTEGER_16]
			l_tmp_21: CE_POINTER [INTEGER_16]
			l_tmp_23: CE_POINTER [INTEGER_16]
			l_tmp_25: CE_POINTER [INTEGER_16]
			l_tmp_26: NATURAL_16
			l_tmp_28: CE_POINTER [INTEGER_16]
			l_tmp_30: CE_POINTER [INTEGER_16]
			l_tmp_32: CE_POINTER [INTEGER_16]
			l_tmp_34: CE_POINTER [INTEGER_16]
			l_tmp_36: CE_POINTER [INTEGER_16]
			l_tmp_38: CE_POINTER [INTEGER_16]
			l_tmp_39: NATURAL_16
			l_tmp_41: CE_POINTER [INTEGER_16]
			l_tmp_43: CE_POINTER [INTEGER_16]
			l_tmp_45: CE_POINTER [INTEGER_16]
			l_tmp_47: CE_POINTER [INTEGER_16]
			l_tmp_49: CE_POINTER [INTEGER_16]
			l_tmp_51: CE_POINTER [INTEGER_16]
			l_tmp_52: NATURAL_16
			l_tmp_54: CE_POINTER [INTEGER_16]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast (a_udata)
					l_ptr := create {CE_INTEGER_16_POINTER}.make_cast (a_stream)
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < a_len) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_swapl := ((((sdl_swap16 ((l_ptr[0]).to_natural_16)).to_integer_16).to_real * l_args.item.left_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapr := ((((sdl_swap16 ((l_ptr[1]).to_natural_16)).to_integer_16).to_real * l_args.item.right_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaplr := ((((sdl_swap16 ((l_ptr[2]).to_natural_16)).to_integer_16).to_real * l_args.item.left_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swaprr := ((((sdl_swap16 ((l_ptr[3]).to_natural_16)).to_integer_16).to_real * l_args.item.right_rear_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapce := ((((sdl_swap16 ((l_ptr[4]).to_natural_16)).to_integer_16).to_real * l_args.item.center_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						l_swapwf := ((((sdl_swap16 ((l_ptr[5]).to_natural_16)).to_integer_16).to_real * l_args.item.lfe_f) * l_args.item.distance_f).truncated_to_integer.to_integer_16
						inspect (l_args.item.room_angle).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 90 then l_pos := -1 + 4
						when 180 then l_pos := -1 + 5
						when 270 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_tmp_5 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_5.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_tmp_7 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_7.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_tmp_9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_9.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_tmp_11 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_11.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_tmp_13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_13.item := (sdl_swap16 (l_swapce.to_natural_16)).to_integer_16
						l_tmp_15 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_15.item := (sdl_swap16 (l_swapwf.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 90
						l_tmp_17 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_17.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_tmp_19 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_19.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_tmp_21 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_21.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_tmp_23 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_23.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_tmp_25 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_26 := sdl_swap16 (l_swapr.to_natural_16)
						l_tmp_25.item := ((l_tmp_26.to_integer_16).to_integer_32 // 2 + ((sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16).to_integer_32 // 2).to_integer_16
						l_tmp_28 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_28.item := (sdl_swap16 (l_swapwf.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 180
						l_tmp_30 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_30.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_tmp_32 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_32.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_tmp_34 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_34.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_tmp_36 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_36.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_tmp_38 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_39 := sdl_swap16 (l_swaprr.to_natural_16)
						l_tmp_38.item := ((l_tmp_39.to_integer_16).to_integer_32 // 2 + ((sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16).to_integer_32 // 2).to_integer_16
						l_tmp_41 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_41.item := (sdl_swap16 (l_swapwf.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 270
						l_tmp_43 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_43.item := (sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16
						l_tmp_45 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_45.item := (sdl_swap16 (l_swapl.to_natural_16)).to_integer_16
						l_tmp_47 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_47.item := (sdl_swap16 (l_swaprr.to_natural_16)).to_integer_16
						l_tmp_49 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_49.item := (sdl_swap16 (l_swapr.to_natural_16)).to_integer_16
						l_tmp_51 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_52 := sdl_swap16 (l_swapl.to_natural_16)
						l_tmp_51.item := ((l_tmp_52.to_integer_16).to_integer_32 // 2 + ((sdl_swap16 (l_swaplr.to_natural_16)).to_integer_16).to_integer_32 // 2).to_integer_16
						l_tmp_54 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp_54.item := (sdl_swap16 (l_swapwf.to_natural_16)).to_integer_16
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_i := (l_i.to_natural_32 + {PLATFORM}.Integer_16_bytes.to_natural_32 * {NATURAL_32} 6).to_integer_32
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_position_args (a_args: CE_POINTER [PD_EFF_POSITIONARGS])
		local
			l_tmp: NATURAL_8
			l_tmp_0: NATURAL_8
			l_tmp_1: REAL_32
			l_tmp_2: REAL_32
			l_tmp_3: NATURAL_8
			l_tmp_4: NATURAL_8
			l_tmp_5: NATURAL_8
			l_tmp_6: REAL_32
			l_tmp_7: REAL_32
			l_tmp_8: REAL_32
		do
			memset (create {CE_VOID_POINTER}.make_cast (a_args), ('%/0/').code, (create {PD_EFF_POSITIONARGS}.make).structure_size.to_natural_32).do_nothing
			a_args.item.in_use := 0
			a_args.item.room_angle := (0).to_integer_16
			l_tmp_0 := (255).to_natural_8
			a_args.item.distance_u8 := l_tmp_0
			l_tmp := l_tmp_0
			a_args.item.right_u8 := l_tmp
			a_args.item.left_u8 := l_tmp
			l_tmp_2 := {REAL_32} 1.0
			a_args.item.distance_f := l_tmp_2
			l_tmp_1 := l_tmp_2
			a_args.item.right_f := l_tmp_1
			a_args.item.left_f := l_tmp_1
			l_tmp_5 := (255).to_natural_8
			a_args.item.lfe_u8 := l_tmp_5
			l_tmp_4 := l_tmp_5
			a_args.item.center_u8 := l_tmp_4
			l_tmp_3 := l_tmp_4
			a_args.item.right_rear_u8 := l_tmp_3
			a_args.item.left_rear_u8 := l_tmp_3
			l_tmp_8 := {REAL_32} 1.0
			a_args.item.lfe_f := l_tmp_8
			l_tmp_7 := l_tmp_8
			a_args.item.center_f := l_tmp_7
			l_tmp_6 := l_tmp_7
			a_args.item.right_rear_f := l_tmp_6
			a_args.item.left_rear_f := l_tmp_6;
			(create {P_MIXER_STATIC}).mix_query_spec (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_NATURAL_16_POINTER}.make_shared (default_pointer), (create {CE_INTEGER_32_POINTER}.make_shared (a_args.c_pointer + (create {PD_EFF_POSITIONARGS}.make).offset_of ("channels")))).do_nothing
		end

	get_position_arg (a_channel: INTEGER_32): CE_POINTER [PD_EFF_POSITIONARGS]
		local
			l_rc: CE_POINTER [ANY]
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			if a_channel < 0 then
				if pos_args_global.item.is_void then
					pos_args_global.item := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast ((malloc ((create {PD_EFF_POSITIONARGS}.make).structure_size.to_natural_32)))
					if pos_args_global.item.is_void then
						sdl_set_error ([ce_string ("Out of memory")])
						Result := (create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						init_position_args (pos_args_global.item)
					end
				end
				if not l_return then
					Result := pos_args_global.item
					l_return := True
				end
			end
			if not l_return and then (a_channel >= position_channels.item) then
				l_rc := realloc (create {CE_VOID_POINTER}.make_cast (pos_args_array.item), (a_channel + 1).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
				if l_rc.is_void then
					sdl_set_error ([ce_string ("Out of memory")])
					Result := (create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer))
					l_return := True
				end
				if not l_return then
					pos_args_array.item := create {CE_POINTER_POINTER [PD_EFF_POSITIONARGS]}.make_cast (l_rc)
					l_i := position_channels.item
					from
					until
						not (l_i <= a_channel)
					loop
						pos_args_array.item[l_i] := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
						l_i := l_i + 1
					end
					position_channels.item := a_channel + 1
				end
			end
			if not l_return and then ((pos_args_array.item[a_channel]).is_void) then
				pos_args_array.item[a_channel] := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_cast ((malloc ((create {PD_EFF_POSITIONARGS}.make).structure_size.to_natural_32)))
				if (pos_args_array.item[a_channel]).is_void then
					sdl_set_error ([ce_string ("Out of memory")])
					Result := (create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer))
					l_return := True
				end
				if not l_return then
					init_position_args (pos_args_array.item[a_channel])
				end
			end
			if not l_return then
				Result := (pos_args_array.item[a_channel])
			end
		end

	get_position_effect_func (a_format: NATURAL_16; a_channels: INTEGER_32): CE_ROUTINE
		local
			l_f: CE_ROUTINE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := create {CE_ROUTINE}.make_shared (default_pointer)
					inspect a_format.to_integer_32 -- switch 1 head
					when 8 then l_pos := -1 + 1
					when 32776 then l_pos := -1 + 6
					when 16 then l_pos := -1 + 11
					when 32784 then l_pos := -1 + 16
					when 4112 then l_pos := -1 + 21
					when 36880 then l_pos := -1 + 26
					else l_pos := -1 + 31
					end
				when 1 then -- switch 1, case 8
					inspect a_channels -- switch 2 head
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 6 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 2 then -- switch 2, case 2 | switch 2, case 1
					if (not ((create {P_EFFECTS_INTERNAL_STATIC}).eff_build_volume_table_u8).is_void) then
						l_f := eff_position_table_u8_address
					else
						l_f := eff_position_u8_address
					end
					l_pos := -1 + 5 -- switch 2; break
				when 3 then -- switch 2, case 4
					l_f := eff_position_u8_c4_address
					l_pos := -1 + 5 -- switch 2; break
				when 4 then -- switch 2, case 6
					l_f := eff_position_u8_c6_address
					l_pos := -1 + 5 -- switch 2; break
				when 5 then -- switch 2, done:
					l_pos := -1 + 32 -- switch 1; break
				when 6 then -- switch 1, case 32776
					inspect a_channels -- switch 3 head
					when 2 then l_pos := -1 + 7
					when 1 then l_pos := -1 + 7
					when 4 then l_pos := -1 + 8
					when 6 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 7 then -- switch 3, case 2 | switch 3, case 1
					if (not ((create {P_EFFECTS_INTERNAL_STATIC}).eff_build_volume_table_s8).is_void) then
						l_f := eff_position_table_s8_address
					else
						l_f := eff_position_s8_address
					end
					l_pos := -1 + 10 -- switch 3; break
				when 8 then -- switch 3, case 4
					l_f := eff_position_s8_c4_address
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 6
					l_f := eff_position_s8_c6_address
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 32 -- switch 1; break
				when 11 then -- switch 1, case 16
					inspect a_channels -- switch 4 head
					when 2 then l_pos := -1 + 12
					when 1 then l_pos := -1 + 12
					when 4 then l_pos := -1 + 13
					when 6 then l_pos := -1 + 14
					else l_pos := -1 + 15
					end
				when 12 then -- switch 4, case 2 | switch 4, case 1
					l_f := eff_position_u16lsb_address
					l_pos := -1 + 15 -- switch 4; break
				when 13 then -- switch 4, case 4
					l_f := eff_position_u16lsb_c4_address
					l_pos := -1 + 15 -- switch 4; break
				when 14 then -- switch 4, case 6
					l_f := eff_position_u16lsb_c6_address
					l_pos := -1 + 15 -- switch 4; break
				when 15 then -- switch 4, done:
					l_pos := -1 + 32 -- switch 1; break
				when 16 then -- switch 1, case 32784
					inspect a_channels -- switch 5 head
					when 2 then l_pos := -1 + 17
					when 1 then l_pos := -1 + 17
					when 4 then l_pos := -1 + 18
					when 6 then l_pos := -1 + 19
					else l_pos := -1 + 20
					end
				when 17 then -- switch 5, case 2 | switch 5, case 1
					l_f := eff_position_s16lsb_address
					l_pos := -1 + 20 -- switch 5; break
				when 18 then -- switch 5, case 4
					l_f := eff_position_s16lsb_c4_address
					l_pos := -1 + 20 -- switch 5; break
				when 19 then -- switch 5, case 6
					l_f := eff_position_s16lsb_c6_address
					l_pos := -1 + 20 -- switch 5; break
				when 20 then -- switch 5, done:
					l_pos := -1 + 32 -- switch 1; break
				when 21 then -- switch 1, case 4112
					inspect a_channels -- switch 6 head
					when 2 then l_pos := -1 + 22
					when 1 then l_pos := -1 + 22
					when 4 then l_pos := -1 + 23
					when 6 then l_pos := -1 + 24
					else l_pos := -1 + 25
					end
				when 22 then -- switch 6, case 2 | switch 6, case 1
					l_f := eff_position_u16msb_address
					l_pos := -1 + 25 -- switch 6; break
				when 23 then -- switch 6, case 4
					l_f := eff_position_u16msb_c4_address
					l_pos := -1 + 25 -- switch 6; break
				when 24 then -- switch 6, case 6
					l_f := eff_position_u16msb_c6_address
					l_pos := -1 + 25 -- switch 6; break
				when 25 then -- switch 6, done:
					l_pos := -1 + 32 -- switch 1; break
				when 26 then -- switch 1, case 36880
					inspect a_channels -- switch 7 head
					when 2 then l_pos := -1 + 27
					when 1 then l_pos := -1 + 27
					when 4 then l_pos := -1 + 28
					when 6 then l_pos := -1 + 29
					else l_pos := -1 + 30
					end
				when 27 then -- switch 7, case 2 | switch 7, case 1
					l_f := eff_position_s16msb_address
					l_pos := -1 + 30 -- switch 7; break
				when 28 then -- switch 7, case 4
					l_f := eff_position_s16msb_c4_address
					l_pos := -1 + 30 -- switch 7; break
				when 29 then -- switch 7, case 6
					l_f := eff_position_s16msb_c6_address
					l_pos := -1 + 30 -- switch 7; break
				when 30 then -- switch 7, done:
					l_pos := -1 + 32 -- switch 1; break
				when 31 then -- switch 1, default:
					sdl_set_error ([ce_string ("Unsupported audio format")])
				when 32 then -- switch 1, done:
					Result := l_f
				when 33 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_amplitudes (a_channels, a_angle, a_room_angle: INTEGER_32)
		local
			l_angle: INTEGER_32
			l_left: INTEGER_32
			l_right: INTEGER_32
			l_left_rear: INTEGER_32
			l_right_rear: INTEGER_32
			l_center: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_angle := a_angle
					l_left := 255
					l_right := 255
					l_left_rear := 255
					l_right_rear := 255
					l_center := 255
					l_angle := (abs (l_angle)) \\ 360
					if a_channels = 2 then
						if l_angle < 90 then
							l_left := 255 - ({REAL_32} 255.0 * (l_angle.to_real / {REAL_32} 89.0)).truncated_to_integer
						elseif l_angle < 180 then
							l_left := ({REAL_32} 255.0 * ((l_angle - 90).to_real / {REAL_32} 89.0)).truncated_to_integer
						elseif l_angle < 270 then
							l_right := 255 - ({REAL_32} 255.0 * ((l_angle - 180).to_real / {REAL_32} 89.0)).truncated_to_integer
						else
							l_right := ({REAL_32} 255.0 * ((l_angle - 270).to_real / {REAL_32} 89.0)).truncated_to_integer
						end
					end
					if a_channels /= 4 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_channels /= 6 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_angle < 45 then
							l_left := ({REAL_32} 255.0 * ((180 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left_rear := 255 - ({REAL_32} 255.0 * ((l_angle + 45).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_right_rear := 255 - ({REAL_32} 255.0 * ((90 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
						elseif l_angle < 90 then
							l_center := ({REAL_32} 255.0 * ((225 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left := ({REAL_32} 255.0 * ((180 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left_rear := 255 - ({REAL_32} 255.0 * ((135 - l_angle).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_right_rear := ({REAL_32} 255.0 * ((90 + l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
						elseif l_angle < 135 then
							l_center := ({REAL_32} 255.0 * ((225 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left := 255 - ({REAL_32} 255.0 * ((l_angle - 45).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_right := ({REAL_32} 255.0 * ((270 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left_rear := ({REAL_32} 255.0 * (l_angle.to_real / {REAL_32} 179.0)).truncated_to_integer
						elseif l_angle < 180 then
							l_center := 255 - ({REAL_32} 255.0 * ((l_angle - 90).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_left := 255 - ({REAL_32} 255.0 * ((225 - l_angle).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_right := ({REAL_32} 255.0 * ((270 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left_rear := ({REAL_32} 255.0 * (l_angle.to_real / {REAL_32} 179.0)).truncated_to_integer
						elseif l_angle < 225 then
							l_center := 255 - ({REAL_32} 255.0 * ((270 - l_angle).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_left := ({REAL_32} 255.0 * ((l_angle - 90).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_right := 255 - ({REAL_32} 255.0 * ((l_angle - 135).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_right_rear := ({REAL_32} 255.0 * ((360 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
						elseif l_angle < 270 then
							l_center := ({REAL_32} 255.0 * ((l_angle - 135).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left := ({REAL_32} 255.0 * ((l_angle - 90).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_right := 255 - ({REAL_32} 255.0 * ((315 - l_angle).to_real / {REAL_32} 89.0)).truncated_to_integer
							l_right_rear := ({REAL_32} 255.0 * ((360 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
						elseif l_angle < 315 then
							l_center := ({REAL_32} 255.0 * ((l_angle - 135).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_right := ({REAL_32} 255.0 * ((l_angle - 180).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left_rear := ({REAL_32} 255.0 * ((450 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_right_rear := 255 - ({REAL_32} 255.0 * ((l_angle - 225).to_real / {REAL_32} 89.0)).truncated_to_integer
						else
							l_right := ({REAL_32} 255.0 * ((l_angle - 180).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_left_rear := ({REAL_32} 255.0 * ((450 - l_angle).to_real / {REAL_32} 179.0)).truncated_to_integer
							l_right_rear := 255 - ({REAL_32} 255.0 * ((405 - l_angle).to_real / {REAL_32} 89.0)).truncated_to_integer
						end
				when 5 then -- if done
					if l_left < 0 then
						l_left := 0
					end
					if l_left > 255 then
						l_left := 255
					end
					if l_right < 0 then
						l_right := 0
					end
					if l_right > 255 then
						l_right := 255
					end
					if l_left_rear < 0 then
						l_left_rear := 0
					end
					if l_left_rear > 255 then
						l_left_rear := 255
					end
					if l_right_rear < 0 then
						l_right_rear := 0
					end
					if l_right_rear > 255 then
						l_right_rear := 255
					end
					if l_center < 0 then
						l_center := 0
					end
					if l_center > 255 then
						l_center := 255
					end
					if a_room_angle = 90 then
						speaker_amplitude.item[0] := l_left_rear.to_natural_8
						speaker_amplitude.item[1] := l_left.to_natural_8
						speaker_amplitude.item[2] := l_right_rear.to_natural_8
						speaker_amplitude.item[3] := l_right.to_natural_8
					elseif a_room_angle = 180 then
						if a_channels = 2 then
							speaker_amplitude.item[0] := l_right.to_natural_8
							speaker_amplitude.item[1] := l_left.to_natural_8
						else
							speaker_amplitude.item[0] := l_right_rear.to_natural_8
							speaker_amplitude.item[1] := l_left_rear.to_natural_8
							speaker_amplitude.item[2] := l_right.to_natural_8
							speaker_amplitude.item[3] := l_left.to_natural_8
						end
					elseif a_room_angle = 270 then
						speaker_amplitude.item[0] := l_right.to_natural_8
						speaker_amplitude.item[1] := l_right_rear.to_natural_8
						speaker_amplitude.item[2] := l_left.to_natural_8
						speaker_amplitude.item[3] := l_left_rear.to_natural_8
					else
						speaker_amplitude.item[0] := l_left.to_natural_8
						speaker_amplitude.item[1] := l_right.to_natural_8
						speaker_amplitude.item[2] := l_left_rear.to_natural_8
						speaker_amplitude.item[3] := l_right_rear.to_natural_8
					end
					speaker_amplitude.item[4] := l_center.to_natural_8
					speaker_amplitude.item[5] := (255).to_natural_8
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mix_set_panning (a_channel: INTEGER_32; a_left, a_right: NATURAL_8): INTEGER_32
		local
			l_f: CE_ROUTINE
			l_channels: CE_ARRAY [INTEGER_32]
			l_format: CE_ARRAY [NATURAL_16]
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_retval: INTEGER_32
			l_angle: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_channels.make (<<1>>)
			create {CE_NATURAL_16_ARRAY} l_format.make (<<1>>)

			l_f := create {CE_ROUTINE}.make_shared (default_pointer)
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
			l_retval := 1;
			(create {P_MIXER_STATIC}).mix_query_spec (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_format, l_channels).do_nothing
			if l_channels.item /= 2 then
				if l_channels.item /= 4 then
					if l_channels.item /= 6 then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return and then (l_channels.item > 2) then
				l_angle := 0
				if a_left.to_integer_32 /= 255 then
					l_angle := a_left.to_integer_32
					l_angle := 127 - l_angle
					l_angle := -l_angle
					l_angle := (l_angle * 90) // 128
				elseif a_right.to_integer_32 /= 255 then
					l_angle := a_left.to_integer_32
					l_angle := 127 - l_angle
					l_angle := -l_angle
					l_angle := (l_angle * 90) // 128
				end
				Result := (mix_set_position (a_channel, l_angle.to_integer_16, (0).to_natural_8))
				l_return := True
			end
			if not l_return then
				l_f := get_position_effect_func (l_format.item, l_channels.item)
				if l_f.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				sdl_lock_audio
				l_args := get_position_arg (a_channel)
				if l_args.is_void then
					sdl_unlock_audio
					Result := 0
					l_return := True
				end
			end
			if not l_return and then ((l_args.item.distance_u8).to_integer_32 = 255) then
				if a_left.to_integer_32 = 255 then
					if a_right.to_integer_32 = 255 then
						if (l_args.item.in_use).to_boolean then
							l_retval := (create {P_MIXER_STATIC}).mix_unregister_effect_locked (a_channel, l_f)
							sdl_unlock_audio
							Result := l_retval
							l_return := True
						else
							sdl_unlock_audio
							Result := 1
							l_return := True
						end
					end
				end
			end
			if not l_return then
				l_args.item.left_u8 := a_left
				l_args.item.left_f := (a_left.to_real_32 / {REAL_32} 255.0)
				l_args.item.right_u8 := a_right
				l_args.item.right_f := (a_right.to_real_32 / {REAL_32} 255.0)
				l_args.item.room_angle := (0).to_integer_16
				if not (l_args.item.in_use).to_boolean then
					l_args.item.in_use := 1
					l_retval := (create {P_MIXER_STATIC}).mix_register_effect_locked (a_channel, l_f, eff_position_done_address, create {CE_VOID_POINTER}.make_cast (l_args))
				end
				sdl_unlock_audio
				Result := l_retval
			end
		end

	mix_set_distance (a_channel: INTEGER_32; a_distance: NATURAL_8): INTEGER_32
		local
			l_distance: NATURAL_8
			l_f: CE_ROUTINE
			l_format: CE_ARRAY [NATURAL_16]
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_channels: CE_ARRAY [INTEGER_32]
			l_retval: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_16_ARRAY} l_format.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_channels.make (<<1>>)

			l_distance := a_distance
			l_f := create {CE_ROUTINE}.make_shared (default_pointer)
			l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
			l_retval := 1;
			(create {P_MIXER_STATIC}).mix_query_spec (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_format, l_channels).do_nothing
			l_f := get_position_effect_func (l_format.item, l_channels.item)
			if l_f.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				sdl_lock_audio
				l_args := get_position_arg (a_channel)
				if l_args.is_void then
					sdl_unlock_audio
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_distance := (255 - l_distance.to_integer_32).to_natural_8
				if l_distance.to_integer_32 = 255 then
					if (l_args.item.left_u8).to_integer_32 = 255 then
						if (l_args.item.right_u8).to_integer_32 = 255 then
							if (l_args.item.in_use).to_boolean then
								l_retval := (create {P_MIXER_STATIC}).mix_unregister_effect_locked (a_channel, l_f)
								sdl_unlock_audio
								Result := l_retval
								l_return := True
							else
								sdl_unlock_audio
								Result := 1
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				l_args.item.distance_u8 := l_distance
				l_args.item.distance_f := (l_distance.to_real_32 / {REAL_32} 255.0)
				if not (l_args.item.in_use).to_boolean then
					l_args.item.in_use := 1
					l_retval := (create {P_MIXER_STATIC}).mix_register_effect_locked (a_channel, l_f, eff_position_done_address, create {CE_VOID_POINTER}.make_cast (l_args))
				end
				sdl_unlock_audio
				Result := l_retval
			end
		end

	mix_set_position (a_channel: INTEGER_32; a_angle: INTEGER_16; a_distance: NATURAL_8): INTEGER_32
		local
			l_angle: INTEGER_16
			l_distance: NATURAL_8
			l_f: CE_ROUTINE
			l_format: CE_ARRAY [NATURAL_16]
			l_channels: CE_ARRAY [INTEGER_32]
			l_args: CE_POINTER [PD_EFF_POSITIONARGS]
			l_room_angle: INTEGER_16
			l_retval: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_16_ARRAY} l_format.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_channels.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_angle := a_angle
					l_distance := a_distance
					l_f := create {CE_ROUTINE}.make_shared (default_pointer)
					l_args := create {CE_CLASS_POINTER [PD_EFF_POSITIONARGS]}.make_shared (default_pointer)
					l_room_angle := (0).to_integer_16
					l_retval := 1;
					(create {P_MIXER_STATIC}).mix_query_spec (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_format, l_channels).do_nothing
					l_f := get_position_effect_func (l_format.item, l_channels.item)
					if l_f.is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_angle := ((abs (l_angle.to_integer_32)) \\ 360).to_integer_16
						sdl_lock_audio
						l_args := get_position_arg (a_channel)
						if l_args.is_void then
							sdl_unlock_audio
							Result := 0
							l_return := True
						end
					end
					if not l_return and then (not l_distance.to_boolean) then
						if not l_angle.to_boolean then
							if (l_args.item.in_use).to_boolean then
								l_retval := (create {P_MIXER_STATIC}).mix_unregister_effect_locked (a_channel, l_f)
								sdl_unlock_audio
								Result := l_retval
								l_return := True
							else
								sdl_unlock_audio
								Result := 1
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if l_channels.item = 2 then
							if l_angle.to_integer_32 > 180 then
								l_room_angle := (180).to_integer_16
							else
								l_room_angle := (0).to_integer_16
							end
						end
						if l_channels.item /= 4 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_channels.item /= 6 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_angle.to_integer_32 > 315 then
							l_room_angle := (0).to_integer_16
						elseif l_angle.to_integer_32 > 225 then
							l_room_angle := (270).to_integer_16
						elseif l_angle.to_integer_32 > 135 then
							l_room_angle := (180).to_integer_16
						elseif l_angle.to_integer_32 > 45 then
							l_room_angle := (90).to_integer_16
						else
							l_room_angle := (0).to_integer_16
						end
				when 6 then -- if done
						l_distance := (255 - l_distance.to_integer_32).to_natural_8
						set_amplitudes (l_channels.item, l_angle.to_integer_32, l_room_angle.to_integer_32)
						l_args.item.left_u8 := speaker_amplitude.item[0]
						l_args.item.left_f := ((speaker_amplitude.item[0]).to_real_32 / {REAL_32} 255.0)
						l_args.item.right_u8 := speaker_amplitude.item[1]
						l_args.item.right_f := ((speaker_amplitude.item[1]).to_real_32 / {REAL_32} 255.0)
						l_args.item.left_rear_u8 := speaker_amplitude.item[2]
						l_args.item.left_rear_f := ((speaker_amplitude.item[2]).to_real_32 / {REAL_32} 255.0)
						l_args.item.right_rear_u8 := speaker_amplitude.item[3]
						l_args.item.right_rear_f := ((speaker_amplitude.item[3]).to_real_32 / {REAL_32} 255.0)
						l_args.item.center_u8 := speaker_amplitude.item[4]
						l_args.item.center_f := ((speaker_amplitude.item[4]).to_real_32 / {REAL_32} 255.0)
						l_args.item.lfe_u8 := speaker_amplitude.item[5]
						l_args.item.lfe_f := ((speaker_amplitude.item[5]).to_real_32 / {REAL_32} 255.0)
						l_args.item.distance_u8 := l_distance
						l_args.item.distance_f := (l_distance.to_real_32 / {REAL_32} 255.0)
						l_args.item.room_angle := l_room_angle
						if not (l_args.item.in_use).to_boolean then
							l_args.item.in_use := 1
							l_retval := (create {P_MIXER_STATIC}).mix_register_effect_locked (a_channel, l_f, eff_position_done_address, create {CE_VOID_POINTER}.make_cast (l_args))
						end
						sdl_unlock_audio
						Result := l_retval
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	eff_position_done_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_done)
		end

	eff_position_u8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u8)
		end

	eff_position_u8_c4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u8_c4)
		end

	eff_position_u8_c6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u8_c6)
		end

	eff_position_table_u8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_table_u8)
		end

	eff_position_s8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s8)
		end

	eff_position_s8_c4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s8_c4)
		end

	eff_position_s8_c6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s8_c6)
		end

	eff_position_table_s8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_table_s8)
		end

	eff_position_u16lsb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u16lsb)
		end

	eff_position_u16lsb_c4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u16lsb_c4)
		end

	eff_position_u16lsb_c6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u16lsb_c6)
		end

	eff_position_s16lsb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s16lsb)
		end

	eff_position_s16lsb_c4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s16lsb_c4)
		end

	eff_position_s16lsb_c6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s16lsb_c6)
		end

	eff_position_u16msb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u16msb)
		end

	eff_position_u16msb_c4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u16msb_c4)
		end

	eff_position_u16msb_c6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_u16msb_c6)
		end

	eff_position_s16msb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s16msb)
		end

	eff_position_s16msb_c4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s16msb_c4)
		end

	eff_position_s16msb_c6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_position_s16msb_c6)
		end

end
