class
	P_EFFECTS_INTERNAL_STATIC

inherit
	CE_UTILITIES
	S_SDL_SDL_STDINC_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	mix_effects_max_speed: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	eff_volume_table: CE_STATIC [CE_POINTER [ANY]]
		once ("PROCESS")
			Result.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
		end

feature {ANY} -- public routines

	mix_init_effects
		do
			mix_effects_max_speed.item := (not (sdl_getenv (ce_string ("MIX_EFFECTSMAXSPEED"))).is_void).to_integer
		end

	mix_deinit_effects
		do
			(create {P_EFFECT_POSITION_STATIC}).eff_position_deinit
		end

	eff_build_volume_table_u8: CE_POINTER [ANY]
		local
			l_volume: INTEGER_32
			l_sample: INTEGER_32
			l_rc: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if not mix_effects_max_speed.item.to_boolean then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if eff_volume_table.item.is_void then
					l_rc := create {CE_NATURAL_8_POINTER}.make_cast ((malloc ((65_536).to_natural_32)))
					if (not l_rc.is_void) then
						eff_volume_table.item := create {CE_VOID_POINTER}.make_cast (l_rc)
						l_volume := 0
						from
						until
							not (not (l_return) and then (l_volume < 256))
						loop
							l_sample := -128
							from
							until
								not (l_sample < 128)
							loop
								l_rc.item := ((((l_sample.to_real).to_double * ((l_volume.to_real).to_double / 255.0)).truncated_to_integer_64.to_natural_8).to_integer_32 + 128).to_natural_8
								l_rc := l_rc + 1
								l_sample := l_sample + 1
							end
							l_volume := l_volume + 1
						end
					end
				end
				Result := eff_volume_table.item
			end
		end

	eff_build_volume_table_s8: CE_POINTER [ANY]
		local
			l_volume: INTEGER_32
			l_sample: INTEGER_32
			l_rc: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if eff_volume_table.item.is_void then
				l_rc := create {CE_INTEGER_8_POINTER}.make_cast ((malloc ((65_536).to_natural_32)))
				if (not l_rc.is_void) then
					eff_volume_table.item := create {CE_VOID_POINTER}.make_cast (l_rc)
					l_volume := 0
					from
					until
						not (not (l_return) and then (l_volume < 256))
					loop
						l_sample := -128
						from
						until
							not (l_sample < 128)
						loop
							l_rc[0] := ((l_sample.to_real).to_double * ((l_volume.to_real).to_double / 255.0)).truncated_to_integer.to_integer_8
							l_rc := l_rc + 1
							l_sample := l_sample + 1
						end
						l_volume := l_volume + 1
					end
				end
			end
			Result := eff_volume_table.item
		end

end
