class
	P_LOAD_VOC_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_SDL_SDL_ERROR_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public routines

	voc_check_header (a_src: CE_POINTER [SD_SDL_RWOPS]): INTEGER_32
		local
			l_signature: CE_ARRAY [NATURAL_8]
			l_datablockofs: CE_ARRAY [NATURAL_16]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_signature.make (<<20>>)
			create {CE_NATURAL_16_ARRAY} l_datablockofs.make (<<1>>);

			(a_src.item.seek).call ([a_src, 0, 0])
			if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_signature), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (20).to_natural_32).to_integer_32, 1])) /= 1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (memcmp (create {CE_VOID_POINTER}.make_cast (l_signature), create {CE_VOID_POINTER}.make_cast (ce_string ("Creative Voice File%/26/")), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (20).to_natural_32))) /= 0 then
					sdl_set_error ([ce_string ("Unrecognized file type (not VOC)")])
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_datablockofs), ({PLATFORM}.Natural_16_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_datablockofs.item := l_datablockofs.item
				if ((a_src.item.seek).integer_32_item ([a_src, (l_datablockofs.item).to_integer_32, 0])) /= (l_datablockofs.item).to_integer_32 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	voc_get_block (a_src: CE_POINTER [SD_SDL_RWOPS]; a_v: CE_POINTER [PD_VOCSTUFF]; a_spec: CE_POINTER [SD_SDL_AUDIOSPEC]): INTEGER_32
		local
			l_bits24: CE_ARRAY [NATURAL_8]
			l_uc: CE_ARRAY [NATURAL_8]
			l_block: CE_ARRAY [NATURAL_8]
			l_sblen: NATURAL_32
			l_new_rate_short: CE_ARRAY [NATURAL_16]
			l_new_rate_long: CE_ARRAY [NATURAL_32]
			l_trash: CE_ARRAY [CE_ARRAY [NATURAL_8]]
			l_period: CE_ARRAY [NATURAL_16]
			l_i: NATURAL_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_bits24.make (<<3>>)
			create {CE_NATURAL_8_ARRAY} l_uc.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_block.make (<<1>>)
			create {CE_NATURAL_16_ARRAY} l_new_rate_short.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_new_rate_long.make (<<1>>)
			create {CE_ARRAY_ARRAY [NATURAL_8]} l_trash.make (<<1, 6>>)
			create {CE_NATURAL_16_ARRAY} l_period.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_v.item.silent := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (a_v.item.rest = {NATURAL_32} 0)) then
						l_pos := -1 + 18 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_block), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
							Result := 1
							l_return := True
						end
						if not l_return and then ((l_block.item).to_integer_32 = 0) then
							Result := 1
							l_return := True
						end
						if not l_return then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_bits24), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (3).to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 1
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 17 -- skip if block
						end
				when 3 then -- if:
						l_sblen := (((((l_bits24[0]).to_integer_32).bit_or ((((l_bits24[1]).to_integer_32).bit_shift_left (8))))).bit_or ((((l_bits24[2]).to_integer_32).bit_shift_left (16)))).to_natural_32
						inspect (l_block.item).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 4
						when 9 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 11
						when 3 then l_pos := -1 + 12
						when 7 then l_pos := -1 + 13
						when 6 then l_pos := -1 + 13
						when 8 then l_pos := -1 + 14
						when 4 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 4 then -- switch 1, case 1
						if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_uc), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
							Result := 0
							l_return := True
						end
						if not l_return and then (not (a_v.item.has_extended).to_boolean) then
							if (l_uc.item).to_integer_32 = 0 then
								sdl_set_error ([ce_string ("VOC Sample rate is zero?")])
								Result := 0
								l_return := True
							end
							if not l_return and then (a_v.item.rate /= {NATURAL_32} 4_294_967_295) then
								if (l_uc.item).to_natural_32 /= a_v.item.rate then
									sdl_set_error ([ce_string ("VOC sample rate codes differ")])
									Result := 0
									l_return := True
								end
							end
							if not l_return then
								a_v.item.rate := (l_uc.item).to_natural_32
								a_spec.item.freq := ((1000000.0 / ({NATURAL_32} 256 - a_v.item.rate).to_real_64).truncated_to_integer_64.to_natural_16).to_integer_32
								a_v.item.channels := (1).to_natural_8
							end
						end
						if not l_return then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_uc), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if not l_return and then ((l_uc.item).to_integer_32 /= 0) then
							sdl_set_error ([ce_string ("VOC decoder only interprets 8-bit data")])
							Result := 0
							l_return := True
						end
						if not l_return then
							a_v.item.has_extended := 0
							a_v.item.rest := l_sblen - {NATURAL_32} 2
							a_v.item.size := (1).to_natural_32
							Result := 1
							l_return := True
						end
				when 5 then -- switch 1, case 9
						if not l_return then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_new_rate_long), ({PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_new_rate_long.item := l_new_rate_long.item
							if l_new_rate_long.item = {NATURAL_32} 0 then
								sdl_set_error ([ce_string ("VOC Sample rate is zero?")])
								Result := 0
								l_return := True
							end
						end
						if not l_return and then (a_v.item.rate /= {NATURAL_32} 4_294_967_295) then
							if l_new_rate_long.item /= a_v.item.rate then
								sdl_set_error ([ce_string ("VOC sample rate codes differ")])
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							a_v.item.rate := l_new_rate_long.item
							a_spec.item.freq := (l_new_rate_long.item).to_integer_32
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_uc), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if:
						inspect (l_uc.item).to_integer_32 -- switch 2 head
						when 8 then l_pos := -1 + 7
						when 16 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 7 then -- switch 2, case 8
						a_v.item.size := (1).to_natural_32
						l_pos := -1 + 10 -- switch 2; break
				when 8 then -- switch 2, case 16
						a_v.item.size := (2).to_natural_32
						l_pos := -1 + 10 -- switch 2; break
				when 9 then -- switch 2, default:
						sdl_set_error ([ce_string ("VOC with unknown data size")])
						Result := 0
						l_return := True
				when 10 then -- switch 2, done: | if done
						if not l_return then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_8_POINTER}.make_shared (a_v.c_pointer + (create {PD_VOCSTUFF}.make).offset_of ("channels")))), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast ((l_trash.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 6])) /= 6 then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							a_v.item.rest := l_sblen - {NATURAL_32} 12
							Result := 1
							l_return := True
						end
				when 11 then -- switch 1, case 2
						if not l_return then
							a_v.item.rest := l_sblen
							Result := 1
							l_return := True
						end
				when 12 then -- switch 1, case 3
						if not l_return then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_period), ({PLATFORM}.Natural_16_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_period.item := l_period.item
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_uc), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if not l_return and then ((l_uc.item).to_integer_32 = 0) then
							sdl_set_error ([ce_string ("VOC silence sample rate is zero")])
							Result := 0
							l_return := True
						end
						if not l_return then
							if a_v.item.rate /= {NATURAL_32} 4_294_967_295 then
								if (l_uc.item).to_natural_32 /= a_v.item.rate then
									l_period.item := (((l_period.item).to_integer_32 * (256 - (l_uc.item).to_integer_32)).to_natural_32 // ({NATURAL_32} 256 - a_v.item.rate)).to_natural_16
								else
									a_v.item.rate := (l_uc.item).to_natural_32
								end
							else
								a_v.item.rate := (l_uc.item).to_natural_32
							end
							a_v.item.rest := (l_period.item).to_natural_32
							a_v.item.silent := 1
							Result := 1
							l_return := True
						end
				when 13 then -- switch 1, case 7 | switch 1, case 6
						if not l_return then
							l_i := {NATURAL_32} 0
							from
							until
								not (not (l_return) and then (l_i < l_sblen))
							loop
								if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast ((l_trash.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
									Result := 0
									l_return := True
								end
								if not l_return then
									l_i := l_i + 1
								end
							end
						end
						l_pos := -1 + 17 -- switch 1; break
				when 14 then -- switch 1, case 8
						a_v.item.has_extended := 1
						if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_new_rate_short), ({PLATFORM}.Natural_16_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_new_rate_short.item := l_new_rate_short.item
							if (l_new_rate_short.item).to_integer_32 = 0 then
								sdl_set_error ([ce_string ("VOC sample rate is zero")])
								Result := 0
								l_return := True
							end
						end
						if not l_return and then (a_v.item.rate /= {NATURAL_32} 4_294_967_295) then
							if (l_new_rate_short.item).to_natural_32 /= a_v.item.rate then
								sdl_set_error ([ce_string ("VOC sample rate codes differ")])
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							a_v.item.rate := (l_new_rate_short.item).to_natural_32
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_uc), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if not l_return and then ((l_uc.item).to_integer_32 /= 0) then
							sdl_set_error ([ce_string ("VOC decoder only interprets 8-bit data")])
							Result := 0
							l_return := True
						end
						if not l_return then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_uc), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							if (l_uc.item).to_boolean then
								a_spec.item.channels := (2).to_natural_8
							end
							a_spec.item.freq := (({NATURAL_32} 256_000_000 // ({NATURAL_32} 65_536 - (a_v.item.rate).to_natural_32)) // (a_spec.item.channels).to_natural_32).to_integer_32
							l_continue := True
						end
				when 15 then -- switch 1, case 4
						if not (l_return or l_continue) then
							if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast ((l_trash.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 2])) /= 2 then
								Result := 0
								l_return := True
							end
						end
				when 16 then -- switch 1, default:
						if not (l_return or l_continue) then
							l_i := {NATURAL_32} 0
							from
							until
								not (not (l_return) and then (l_i < l_sblen))
							loop
								if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (l_trash), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 1])) /= 1 then
									Result := 0
									l_return := True
								end
								if not l_return then
									l_i := l_i + 1
								end
							end
							if not l_return and then ((l_block.item).to_integer_32 = 5) then
								l_continue := True
							end
						end
				when 17 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 18 then -- loop done
					if not l_return then
						l_continue := False
						Result := 1
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	voc_read (a_src: CE_POINTER [SD_SDL_RWOPS]; a_v: CE_POINTER [PD_VOCSTUFF]; a_buf: CE_POINTER [NATURAL_8]; a_spec: CE_POINTER [SD_SDL_AUDIOSPEC]): INTEGER_32
		local
			l_done: INTEGER_32
			l_silence: NATURAL_8
			l_return: BOOLEAN
		do
			l_done := 0
			l_silence := (128).to_natural_8
			if a_v.item.rest = {NATURAL_32} 0 then
				if not (voc_get_block (a_src, a_v, a_spec)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (a_v.item.rest = {NATURAL_32} 0) then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (a_v.item.silent).to_boolean then
					if a_v.item.size = {NATURAL_32} 2 then
						l_silence := (0).to_natural_8
					end
					memset (create {CE_VOID_POINTER}.make_cast (a_buf), l_silence.to_integer_32, a_v.item.rest).do_nothing
					l_done := (a_v.item.rest).to_integer_32
					a_v.item.rest := (0).to_natural_32
				else
					l_done := (a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (a_buf), 1, (a_v.item.rest).to_integer_32])
					a_v.item.rest := a_v.item.rest - l_done.to_natural_32
					if a_v.item.size = {NATURAL_32} 2 then
						l_done := (l_done).bit_shift_right ((1))
					end
				end
				Result := l_done
			end
		end

	mix_load_voc_rw (a_src: CE_POINTER [SD_SDL_RWOPS]; a_freesrc: INTEGER_32; a_spec: CE_POINTER [SD_SDL_AUDIOSPEC]; a_audio_buf: CE_POINTER [CE_POINTER [NATURAL_8]]; a_audio_len: CE_POINTER [NATURAL_32]): CE_POINTER [SD_SDL_AUDIOSPEC]
		local
			l_spec: CE_POINTER [SD_SDL_AUDIOSPEC]
			l_v: CE_ARRAY [PD_VOCSTUFF]
			l_was_error: INTEGER_32
			l_samplesize: INTEGER_32
			l_fillptr: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [ANY]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_VOCSTUFF]} l_v.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_spec := a_spec
					l_was_error := 1
					if a_src.is_void then
						l_pos := -1 + 13 -- goto done
					elseif a_audio_buf.is_void then
						l_pos := -1 + 13 -- goto done
					elseif a_audio_len.is_void then
						l_pos := -1 + 13 -- goto done
					end
				when 1 then
					if not (voc_check_header (a_src)).to_boolean then
						l_pos := -1 + 13 -- goto done
					end
				when 2 then
					l_v.item.rate := (-1).to_natural_32
					l_v.item.rest := (0).to_natural_32
					l_v.item.has_extended := 0
					a_audio_buf.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					a_audio_len.item := (0).to_natural_32
					memset (create {CE_VOID_POINTER}.make_cast (l_spec), ('%/0/').code, (create {SD_SDL_AUDIOSPEC}.make).structure_size.to_natural_32).do_nothing
					if not (voc_get_block (a_src, l_v, l_spec)).to_boolean then
						l_pos := -1 + 13 -- goto done
					end
				when 3 then
					if l_v.item.rate = {NATURAL_32} 4_294_967_295 then
						sdl_set_error ([ce_string ("VOC data had no sound!")])
						l_pos := -1 + 13 -- goto done
					end
				when 4 then
					if l_v.item.size = {NATURAL_32} 2 then
						l_spec.item.format := (32_784).to_natural_16
					else
						l_spec.item.format := (8).to_natural_16
					end
					if (l_spec.item.channels).to_integer_32 = 0 then
						l_spec.item.channels := l_v.item.channels
					end
					a_audio_len.item := l_v.item.rest
					a_audio_buf.item := create {CE_NATURAL_8_POINTER}.make_cast ((malloc (l_v.item.rest)))
					if (a_audio_buf.item).is_void then
						l_pos := -1 + 13 -- goto done
					end
				when 5 then
					l_fillptr := a_audio_buf.item
				when 6 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 12 -- skip loop
					end
				when 7 then -- loop body:
						l_break := False
						if not ((voc_read (a_src, l_v, l_fillptr, l_spec)) > 0) then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						if not (voc_get_block (a_src, l_v, l_spec)).to_boolean then
							l_pos := -1 + 13 -- goto done
						end
				when 9 then
						a_audio_len.item := a_audio_len.item + (l_v.item.rest)
						l_ptr := realloc (create {CE_VOID_POINTER}.make_cast (a_audio_buf.item), a_audio_len.item)
						if l_ptr.is_void then
							free (create {CE_VOID_POINTER}.make_cast (a_audio_buf.item))
							a_audio_buf.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							a_audio_len.item := (0).to_natural_32
							l_pos := -1 + 13 -- goto done
						end
				when 10 then
						a_audio_buf.item := create {CE_NATURAL_8_POINTER}.make_cast (l_ptr)
						l_fillptr := create {CE_NATURAL_8_POINTER}.make_cast (l_ptr) + (a_audio_len.item - l_v.item.rest).to_integer_32
				when 11 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 12 then -- loop done
					l_break := False
					l_spec.item.samples := (a_audio_len.item // l_v.item.size).to_natural_16
					l_was_error := 0
					l_samplesize := ((((l_spec.item.format).to_integer_32).bit_and (255)) // 8) * (l_spec.item.channels).to_integer_32
					a_audio_len.item := (a_audio_len.item).bit_and ((((l_samplesize - 1)).bit_not).to_natural_32)
				when 13 then -- done:
					if (not a_src.is_void) then
						if a_freesrc.to_boolean then
							(a_src.item.close).call ([a_src])
						else
							(a_src.item.seek).call ([a_src, 0, 0])
						end
					end
					if l_was_error.to_boolean then
						l_spec := create {CE_CLASS_POINTER [SD_SDL_AUDIOSPEC]}.make_shared (default_pointer)
					end
					Result := l_spec
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
