class
	PD_MIX_EFFECTINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_callback: CE_ROUTINE
				a_done_callback: CE_ROUTINE
				a_udata: CE_POINTER [ANY]
				a_next: CE_POINTER [PD_MIX_EFFECTINFO]
			])
		require else
			a_data /= Void
		do
			make
			Current.callback := a_data.a_callback
			Current.done_callback := a_data.a_done_callback
			Current.udata := a_data.a_udata
			Current.next := a_data.a_next
		end

feature {ANY} -- fields

	callback: CE_ROUTINE assign set_callback
		do
			create Result.make_shared (c__callback (internal_c_pointer))
		end

	done_callback: CE_ROUTINE assign set_done_callback
		do
			create Result.make_shared (c__done_callback (internal_c_pointer))
		end

	udata: CE_POINTER [ANY] assign set_udata
		do
			create {CE_VOID_POINTER} Result.make_shared (c__udata (internal_c_pointer))
		end

	next: CE_POINTER [PD_MIX_EFFECTINFO] assign set_next
		do
			create {CE_CLASS_POINTER [PD_MIX_EFFECTINFO]} Result.make_shared (c__next (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_callback (a_callback: CE_ROUTINE)
		do
			c__set_callback (internal_c_pointer, a_callback.c_pointer)
		end

	set_done_callback (a_done_callback: CE_ROUTINE)
		do
			c__set_done_callback (internal_c_pointer, a_done_callback.c_pointer)
		end

	set_udata (a_udata: CE_POINTER [ANY])
		do
			c__set_udata (internal_c_pointer, a_udata.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_MIX_EFFECTINFO])
		do
			c__set_next (internal_c_pointer, a_next.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct _Mix_effectinfo);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct _Mix_effectinfo);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__callback (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _Mix_effectinfo *)$a_c_pointer)->callback;"
		end

	c__done_callback (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _Mix_effectinfo *)$a_c_pointer)->done_callback;"
		end

	c__udata (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _Mix_effectinfo *)$a_c_pointer)->udata;"
		end

	c__next (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _Mix_effectinfo *)$a_c_pointer)->next;"
		end

	c__set_callback (a_c_pointer: POINTER; a_callback: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_effectinfo *)$a_c_pointer)->callback = $a_callback;"
		end

	c__set_done_callback (a_c_pointer: POINTER; a_done_callback: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_effectinfo *)$a_c_pointer)->done_callback = $a_done_callback;"
		end

	c__set_udata (a_c_pointer: POINTER; a_udata: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_effectinfo *)$a_c_pointer)->udata = $a_udata;"
		end

	c__set_next (a_c_pointer: POINTER; a_next: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_effectinfo *)$a_c_pointer)->next = $a_next;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "callback") == 0) return offsetof(struct _Mix_effectinfo, callback);
				if(strcmp($a_field_name, "done_callback") == 0) return offsetof(struct _Mix_effectinfo, done_callback);
				if(strcmp($a_field_name, "udata") == 0) return offsetof(struct _Mix_effectinfo, udata);
				if(strcmp($a_field_name, "next") == 0) return offsetof(struct _Mix_effectinfo, next);
				fprintf(stderr, "struct _Mix_effectinfo.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
