class
	PD_MIX_MUSIC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_type: NATURAL_32
				a_data: PD_DATA
				a_fading: NATURAL_32
				a_fade_step: INTEGER_32
				a_fade_steps: INTEGER_32
				a_error: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.type := a_data.a_type
			data.c_pointer.memory_copy (a_data.a_data.c_pointer, a_data.a_data.structure_size)
			Current.fading := a_data.a_fading
			Current.fade_step := a_data.a_fade_step
			Current.fade_steps := a_data.a_fade_steps
			Current.error := a_data.a_error
		end

feature {ANY} -- fields

	type: NATURAL_32 assign set_type
		do
			Result := c__type (internal_c_pointer)
		end

	data: PD_DATA
		once ("OBJECT")
			create Result.make_shared (c__data (internal_c_pointer))
		end

	fading: NATURAL_32 assign set_fading
		do
			Result := c__fading (internal_c_pointer)
		end

	fade_step: INTEGER_32 assign set_fade_step
		do
			Result := c__fade_step (internal_c_pointer)
		end

	fade_steps: INTEGER_32 assign set_fade_steps
		do
			Result := c__fade_steps (internal_c_pointer)
		end

	error: INTEGER_32 assign set_error
		do
			Result := c__error (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_type (a_type: NATURAL_32)
		do
			c__set_type (internal_c_pointer, a_type)
		end

	set_fading (a_fading: NATURAL_32)
		do
			c__set_fading (internal_c_pointer, a_fading)
		end

	set_fade_step (a_fade_step: INTEGER_32)
		do
			c__set_fade_step (internal_c_pointer, a_fade_step)
		end

	set_fade_steps (a_fade_steps: INTEGER_32)
		do
			c__set_fade_steps (internal_c_pointer, a_fade_steps)
		end

	set_error (a_error: INTEGER_32)
		do
			c__set_error (internal_c_pointer, a_error)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct _Mix_Music);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct _Mix_Music);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__type (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Music *)$a_c_pointer)->type;"
		end

	c__data (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)&((struct _Mix_Music *)$a_c_pointer)->data;"
		end

	c__fading (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Music *)$a_c_pointer)->fading;"
		end

	c__fade_step (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Music *)$a_c_pointer)->fade_step;"
		end

	c__fade_steps (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Music *)$a_c_pointer)->fade_steps;"
		end

	c__error (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Music *)$a_c_pointer)->error;"
		end

	c__set_type (a_c_pointer: POINTER; a_type: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Music *)$a_c_pointer)->type = $a_type;"
		end

	c__set_fading (a_c_pointer: POINTER; a_fading: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Music *)$a_c_pointer)->fading = $a_fading;"
		end

	c__set_fade_step (a_c_pointer: POINTER; a_fade_step: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Music *)$a_c_pointer)->fade_step = $a_fade_step;"
		end

	c__set_fade_steps (a_c_pointer: POINTER; a_fade_steps: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Music *)$a_c_pointer)->fade_steps = $a_fade_steps;"
		end

	c__set_error (a_c_pointer: POINTER; a_error: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Music *)$a_c_pointer)->error = $a_error;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "type") == 0) return offsetof(struct _Mix_Music, type);
				if(strcmp($a_field_name, "data") == 0) return offsetof(struct _Mix_Music, data);
				if(strcmp($a_field_name, "fading") == 0) return offsetof(struct _Mix_Music, fading);
				if(strcmp($a_field_name, "fade_step") == 0) return offsetof(struct _Mix_Music, fade_step);
				if(strcmp($a_field_name, "fade_steps") == 0) return offsetof(struct _Mix_Music, fade_steps);
				if(strcmp($a_field_name, "error") == 0) return offsetof(struct _Mix_Music, error);
				fprintf(stderr, "struct _Mix_Music.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
