class
	PD_VOCSTUFF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_rest: NATURAL_32
				a_rate: NATURAL_32
				a_silent: INTEGER_32
				a_srate: NATURAL_32
				a_blockseek: NATURAL_32
				a_samples: NATURAL_32
				a_size: NATURAL_32
				a_channels: NATURAL_8
				a_has_extended: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.rest := a_data.a_rest
			Current.rate := a_data.a_rate
			Current.silent := a_data.a_silent
			Current.srate := a_data.a_srate
			Current.blockseek := a_data.a_blockseek
			Current.samples := a_data.a_samples
			Current.size := a_data.a_size
			Current.channels := a_data.a_channels
			Current.has_extended := a_data.a_has_extended
		end

feature {ANY} -- fields

	rest: NATURAL_32 assign set_rest
		do
			Result := c__rest (internal_c_pointer)
		end

	rate: NATURAL_32 assign set_rate
		do
			Result := c__rate (internal_c_pointer)
		end

	silent: INTEGER_32 assign set_silent
		do
			Result := c__silent (internal_c_pointer)
		end

	srate: NATURAL_32 assign set_srate
		do
			Result := c__srate (internal_c_pointer)
		end

	blockseek: NATURAL_32 assign set_blockseek
		do
			Result := c__blockseek (internal_c_pointer)
		end

	samples: NATURAL_32 assign set_samples
		do
			Result := c__samples (internal_c_pointer)
		end

	size: NATURAL_32 assign set_size
		do
			Result := c__size (internal_c_pointer)
		end

	channels: NATURAL_8 assign set_channels
		do
			Result := c__channels (internal_c_pointer)
		end

	has_extended: INTEGER_32 assign set_has_extended
		do
			Result := c__has_extended (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_rest (a_rest: NATURAL_32)
		do
			c__set_rest (internal_c_pointer, a_rest)
		end

	set_rate (a_rate: NATURAL_32)
		do
			c__set_rate (internal_c_pointer, a_rate)
		end

	set_silent (a_silent: INTEGER_32)
		do
			c__set_silent (internal_c_pointer, a_silent)
		end

	set_srate (a_srate: NATURAL_32)
		do
			c__set_srate (internal_c_pointer, a_srate)
		end

	set_blockseek (a_blockseek: NATURAL_32)
		do
			c__set_blockseek (internal_c_pointer, a_blockseek)
		end

	set_samples (a_samples: NATURAL_32)
		do
			c__set_samples (internal_c_pointer, a_samples)
		end

	set_size (a_size: NATURAL_32)
		do
			c__set_size (internal_c_pointer, a_size)
		end

	set_channels (a_channels: NATURAL_8)
		do
			c__set_channels (internal_c_pointer, a_channels)
		end

	set_has_extended (a_has_extended: INTEGER_32)
		do
			c__set_has_extended (internal_c_pointer, a_has_extended)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct vocstuff);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct vocstuff);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__rest (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->rest;"
		end

	c__rate (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->rate;"
		end

	c__silent (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->silent;"
		end

	c__srate (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->srate;"
		end

	c__blockseek (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->blockseek;"
		end

	c__samples (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->samples;"
		end

	c__size (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->size;"
		end

	c__channels (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->channels;"
		end

	c__has_extended (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct vocstuff *)$a_c_pointer)->has_extended;"
		end

	c__set_rest (a_c_pointer: POINTER; a_rest: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->rest = $a_rest;"
		end

	c__set_rate (a_c_pointer: POINTER; a_rate: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->rate = $a_rate;"
		end

	c__set_silent (a_c_pointer: POINTER; a_silent: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->silent = $a_silent;"
		end

	c__set_srate (a_c_pointer: POINTER; a_srate: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->srate = $a_srate;"
		end

	c__set_blockseek (a_c_pointer: POINTER; a_blockseek: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->blockseek = $a_blockseek;"
		end

	c__set_samples (a_c_pointer: POINTER; a_samples: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->samples = $a_samples;"
		end

	c__set_size (a_c_pointer: POINTER; a_size: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->size = $a_size;"
		end

	c__set_channels (a_c_pointer: POINTER; a_channels: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->channels = $a_channels;"
		end

	c__set_has_extended (a_c_pointer: POINTER; a_has_extended: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct vocstuff *)$a_c_pointer)->has_extended = $a_has_extended;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "rest") == 0) return offsetof(struct vocstuff, rest);
				if(strcmp($a_field_name, "rate") == 0) return offsetof(struct vocstuff, rate);
				if(strcmp($a_field_name, "silent") == 0) return offsetof(struct vocstuff, silent);
				if(strcmp($a_field_name, "srate") == 0) return offsetof(struct vocstuff, srate);
				if(strcmp($a_field_name, "blockseek") == 0) return offsetof(struct vocstuff, blockseek);
				if(strcmp($a_field_name, "samples") == 0) return offsetof(struct vocstuff, samples);
				if(strcmp($a_field_name, "size") == 0) return offsetof(struct vocstuff, size);
				if(strcmp($a_field_name, "channels") == 0) return offsetof(struct vocstuff, channels);
				if(strcmp($a_field_name, "has_extended") == 0) return offsetof(struct vocstuff, has_extended);
				fprintf(stderr, "struct vocstuff.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
