class
	PD_WAVEFMT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_encoding: NATURAL_16
				a_channels: NATURAL_16
				a_frequency: NATURAL_32
				a_byterate: NATURAL_32
				a_blockalign: NATURAL_16
				a_bitspersample: NATURAL_16
			])
		require else
			a_data /= Void
		do
			make
			Current.encoding := a_data.a_encoding
			Current.channels := a_data.a_channels
			Current.frequency := a_data.a_frequency
			Current.byterate := a_data.a_byterate
			Current.blockalign := a_data.a_blockalign
			Current.bitspersample := a_data.a_bitspersample
		end

feature {ANY} -- fields

	encoding: NATURAL_16 assign set_encoding
		do
			Result := c__encoding (internal_c_pointer)
		end

	channels: NATURAL_16 assign set_channels
		do
			Result := c__channels (internal_c_pointer)
		end

	frequency: NATURAL_32 assign set_frequency
		do
			Result := c__frequency (internal_c_pointer)
		end

	byterate: NATURAL_32 assign set_byterate
		do
			Result := c__byterate (internal_c_pointer)
		end

	blockalign: NATURAL_16 assign set_blockalign
		do
			Result := c__blockalign (internal_c_pointer)
		end

	bitspersample: NATURAL_16 assign set_bitspersample
		do
			Result := c__bitspersample (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_encoding (a_encoding: NATURAL_16)
		do
			c__set_encoding (internal_c_pointer, a_encoding)
		end

	set_channels (a_channels: NATURAL_16)
		do
			c__set_channels (internal_c_pointer, a_channels)
		end

	set_frequency (a_frequency: NATURAL_32)
		do
			c__set_frequency (internal_c_pointer, a_frequency)
		end

	set_byterate (a_byterate: NATURAL_32)
		do
			c__set_byterate (internal_c_pointer, a_byterate)
		end

	set_blockalign (a_blockalign: NATURAL_16)
		do
			c__set_blockalign (internal_c_pointer, a_blockalign)
		end

	set_bitspersample (a_bitspersample: NATURAL_16)
		do
			c__set_bitspersample (internal_c_pointer, a_bitspersample)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct WaveFMT);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct WaveFMT);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__encoding (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct WaveFMT *)$a_c_pointer)->encoding;"
		end

	c__channels (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct WaveFMT *)$a_c_pointer)->channels;"
		end

	c__frequency (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct WaveFMT *)$a_c_pointer)->frequency;"
		end

	c__byterate (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct WaveFMT *)$a_c_pointer)->byterate;"
		end

	c__blockalign (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct WaveFMT *)$a_c_pointer)->blockalign;"
		end

	c__bitspersample (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct WaveFMT *)$a_c_pointer)->bitspersample;"
		end

	c__set_encoding (a_c_pointer: POINTER; a_encoding: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct WaveFMT *)$a_c_pointer)->encoding = $a_encoding;"
		end

	c__set_channels (a_c_pointer: POINTER; a_channels: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct WaveFMT *)$a_c_pointer)->channels = $a_channels;"
		end

	c__set_frequency (a_c_pointer: POINTER; a_frequency: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct WaveFMT *)$a_c_pointer)->frequency = $a_frequency;"
		end

	c__set_byterate (a_c_pointer: POINTER; a_byterate: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct WaveFMT *)$a_c_pointer)->byterate = $a_byterate;"
		end

	c__set_blockalign (a_c_pointer: POINTER; a_blockalign: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct WaveFMT *)$a_c_pointer)->blockalign = $a_blockalign;"
		end

	c__set_bitspersample (a_c_pointer: POINTER; a_bitspersample: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct WaveFMT *)$a_c_pointer)->bitspersample = $a_bitspersample;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "encoding") == 0) return offsetof(struct WaveFMT, encoding);
				if(strcmp($a_field_name, "channels") == 0) return offsetof(struct WaveFMT, channels);
				if(strcmp($a_field_name, "frequency") == 0) return offsetof(struct WaveFMT, frequency);
				if(strcmp($a_field_name, "byterate") == 0) return offsetof(struct WaveFMT, byterate);
				if(strcmp($a_field_name, "blockalign") == 0) return offsetof(struct WaveFMT, blockalign);
				if(strcmp($a_field_name, "bitspersample") == 0) return offsetof(struct WaveFMT, bitspersample);
				fprintf(stderr, "struct WaveFMT.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
