class
	PD_WAVSTREAM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_rw: CE_POINTER [SD_SDL_RWOPS]
				a_freerw: NATURAL_32
				a_start: INTEGER_32
				a_stop: INTEGER_32
				a_cvt: SD_SDL_AUDIOCVT
			])
		require else
			a_data /= Void
		do
			make
			Current.rw := a_data.a_rw
			Current.freerw := a_data.a_freerw
			Current.start := a_data.a_start
			Current.stop := a_data.a_stop
			cvt.c_pointer.memory_copy (a_data.a_cvt.c_pointer, a_data.a_cvt.structure_size)
		end

feature {ANY} -- fields

	rw: CE_POINTER [SD_SDL_RWOPS] assign set_rw
		do
			create {CE_CLASS_POINTER [SD_SDL_RWOPS]} Result.make_shared (c__rw (internal_c_pointer))
		end

	freerw: NATURAL_32 assign set_freerw
		do
			Result := c__freerw (internal_c_pointer)
		end

	start: INTEGER_32 assign set_start
		do
			Result := c__start (internal_c_pointer)
		end

	stop: INTEGER_32 assign set_stop
		do
			Result := c__stop (internal_c_pointer)
		end

	cvt: SD_SDL_AUDIOCVT assign set_cvt
		once ("OBJECT")
			create Result.make_shared (c__cvt (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_rw (a_rw: CE_POINTER [SD_SDL_RWOPS])
		do
			c__set_rw (internal_c_pointer, a_rw.c_pointer)
		end

	set_freerw (a_freerw: NATURAL_32)
		do
			c__set_freerw (internal_c_pointer, a_freerw)
		end

	set_start (a_start: INTEGER_32)
		do
			c__set_start (internal_c_pointer, a_start)
		end

	set_stop (a_stop: INTEGER_32)
		do
			c__set_stop (internal_c_pointer, a_stop)
		end

	set_cvt (a_cvt: SD_SDL_AUDIOCVT)
		do
			c__set_cvt (internal_c_pointer, a_cvt.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct __anonstruct_WAVStream_42);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct __anonstruct_WAVStream_42);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__rw (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->rw;"
		end

	c__freerw (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->freerw;"
		end

	c__start (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->start;"
		end

	c__stop (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->stop;"
		end

	c__cvt (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->cvt;"
		end

	c__set_rw (a_c_pointer: POINTER; a_rw: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->rw = $a_rw;"
		end

	c__set_freerw (a_c_pointer: POINTER; a_freerw: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->freerw = $a_freerw;"
		end

	c__set_start (a_c_pointer: POINTER; a_start: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->start = $a_start;"
		end

	c__set_stop (a_c_pointer: POINTER; a_stop: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->stop = $a_stop;"
		end

	c__set_cvt (a_c_pointer: POINTER; a_cvt: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_WAVStream_42 *)$a_c_pointer)->cvt = *(struct SDL_AudioCVT *)$a_cvt;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "rw") == 0) return offsetof(struct __anonstruct_WAVStream_42, rw);
				if(strcmp($a_field_name, "freerw") == 0) return offsetof(struct __anonstruct_WAVStream_42, freerw);
				if(strcmp($a_field_name, "start") == 0) return offsetof(struct __anonstruct_WAVStream_42, start);
				if(strcmp($a_field_name, "stop") == 0) return offsetof(struct __anonstruct_WAVStream_42, stop);
				if(strcmp($a_field_name, "cvt") == 0) return offsetof(struct __anonstruct_WAVStream_42, cvt);
				fprintf(stderr, "struct __anonstruct_WAVStream_42.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
