#ifndef SDL_MIXER_H
#define SDL_MIXER_H

#include <ffi.h>
#include <stdio.h>
#include <SDL/SDL_rwops.h>
#include <SDL/SDL_audio.h>
#include <SDL/SDL_version.h>
#include <SDL/SDL_stdinc.h>
#include <smpeg/smpeg.h>
#include <SDL/SDL_error.h>
#include <stdlib.h>
#include <string.h>
#include <SDL/SDL_endian.h>
#include <SDL/SDL_timer.h>
#include <ctype.h>

#undef left_f
#undef right_f
#undef left_u8
#undef right_u8
#undef left_rear_f
#undef right_rear_f
#undef center_f
#undef lfe_f
#undef left_rear_u8
#undef right_rear_u8
#undef center_u8
#undef lfe_u8
#undef distance_f
#undef distance_u8
#undef room_angle
#undef in_use
#undef channels
#undef _ptr
#undef _cnt
#undef _base
#undef _flag
#undef _file
#undef _charbuf
#undef _bufsiz
#undef _tmpfname
#undef data
#undef size
#undef left
#undef append
#undef h
#undef buffer
#undef autoclose
#undef fp
#undef base
#undef here
#undef stop
#undef data1
#undef win32io
#undef stdio
#undef mem
#undef unknown
#undef seek
#undef read
#undef write
#undef close
#undef type
#undef hidden
#undef freq
#undef format
#undef silence
#undef samples
#undef padding
#undef callback
#undef userdata
#undef rest
#undef rate
#undef silent
#undef srate
#undef blockseek
#undef has_extended
#undef needed
#undef src_format
#undef dst_format
#undef rate_incr
#undef buf
#undef len
#undef len_cvt
#undef len_mult
#undef len_ratio
#undef filters
#undef filter_index
#undef major
#undef minor
#undef patch
#undef allocated
#undef abuf
#undef alen
#undef volume
#undef done_callback
#undef udata
#undef next
#undef chunk
#undef playing
#undef paused
#undef looping
#undef tag
#undef expire
#undef start_time
#undef fading
#undef fade_volume
#undef fade_volume_reset
#undef fade_length
#undef ticks_fade
#undef effects
#undef rw
#undef freerw
#undef start
#undef cvt
#undef has_audio
#undef has_video
#undef width
#undef height
#undef current_frame
#undef current_fps
#undef audio_string
#undef audio_current_frame
#undef current_offset
#undef total_size
#undef current_time
#undef total_time
#undef loaded
#undef handle
#undef SMPEG_actualSpec
#undef SMPEG_delete
#undef SMPEG_enableaudio
#undef SMPEG_enablevideo
#undef SMPEG_new_rwops
#undef SMPEG_play
#undef SMPEG_playAudio
#undef SMPEG_rewind
#undef SMPEG_setvolume
#undef SMPEG_skip
#undef SMPEG_status
#undef SMPEG_stop
#undef wave
#undef mp3
#undef fade_step
#undef fade_steps
#undef error
#undef encoding
#undef frequency
#undef byterate
#undef blockalign
#undef bitspersample
#undef magic
#undef length
#undef _vsnprintf
#undef _Dest
#undef _Count
#undef _Format
#undef _Args
#undef vsnprintf
#undef s
#undef n
#undef arg
#undef _vsnwprintf
#undef vsnwprintf
#undef _exit
#undef _Code
#undef _Exit
#undef status
#undef abs
#undef _X
#undef _i64toa
#undef _Val
#undef _DstBuf
#undef _Radix
#undef _ui64toa
#undef _atoi64
#undef _String
#undef free
#undef _Memory
#undef malloc
#undef _Size
#undef realloc
#undef _NewSize
#undef _i64tow
#undef _ui64tow
#undef _wtoi64
#undef _Str
#undef llabs
#undef _j
#undef atoll
#undef _c
#undef lltoa
#undef _n
#undef _i
#undef ulltoa
#undef wtoll
#undef _w
#undef lltow
#undef ulltow
#undef memset
#undef _Dst
#undef _stricmp
#undef _Str1
#undef _Str2
#undef _strnicmp
#undef _MaxCount
#undef strncasecmp
#undef __sz1
#undef __sz2
#undef __sizeMaxCompare
#undef strcasecmp
#undef SDL_SetError
#undef fmt
#undef SDL_LockAudio
#undef SDL_UnlockAudio
#undef SDL_getenv
#undef name
#undef SDL_ReadBE16
#undef src
#undef SDL_ReadLE32
#undef SDL_ReadBE32
#undef memcmp
#undef _Buf1
#undef _Buf2
#undef calloc
#undef _NumOfElements
#undef _SizeOfElements
#undef memcpy
#undef _Src
#undef SDL_GetTicks
#undef SDL_OpenAudio
#undef desired
#undef obtained
#undef SDL_PauseAudio
#undef pause_on
#undef SDL_LoadWAV_RW
#undef freesrc
#undef spec
#undef audio_buf
#undef audio_len
#undef SDL_BuildAudioCVT
#undef src_channels
#undef src_rate
#undef dst_channels
#undef dst_rate
#undef SDL_ConvertAudio
#undef SDL_MixAudio
#undef dst
#undef SDL_CloseAudio
#undef strcpy
#undef _Source
#undef strcmp
#undef strlen
#undef strncmp
#undef strrchr
#undef _Ch
#undef toupper
#undef _C
#undef SDL_GetError
#undef SDL_RWFromFile
#undef file
#undef mode
#undef SDL_FreeRW
#undef area
#undef SDL_Delay
#undef ms
#undef SDL_Error
#undef code
#undef info
#undef sdl_audio
#undef mpeg
#undef enable
#undef seconds
#undef stream

enum PC_mix_fading {
	MIX_NO_FADING = 0,
	MIX_FADING_OUT = 1,
	MIX_FADING_IN = 2
};
enum PC_mix_musictype {
	MUS_NONE = 0,
	MUS_CMD = 1,
	MUS_WAV = 2,
	MUS_MOD = 3,
	MUS_MID = 4,
	MUS_OGG = 5,
	MUS_MP3 = 6,
	MUS_MP3_MAD = 7,
	MUS_FLAC = 8,
	MUS_MODPLUG = 9
};

struct _Eff_positionargs;
struct __anonstruct_buffer_15;
struct __anonstruct_win32io_14;
struct __anonstruct_stdio_16;
struct __anonstruct_mem_17;
struct __anonstruct_unknown_18;
union __anonunion_hidden_13;
struct vocstuff;
struct Mix_Chunk;
struct _Mix_effectinfo;
struct _Mix_Channel;
struct __anonstruct_WAVStream_42;
struct __anonstruct_smpeg_loader_53;
union __anonunion_data_54;
struct _Mix_Music;
struct WaveFMT;
struct Chunk;

typedef struct __anonstruct_WAVStream_42 WAVStream;
typedef struct __anonstruct_smpeg_loader_53 smpeg_loader;

struct _Eff_positionargs {
	float volatile left_f;
	float volatile right_f;
	unsigned char left_u8;
	unsigned char right_u8;
	float volatile left_rear_f;
	float volatile right_rear_f;
	float volatile center_f;
	float volatile lfe_f;
	unsigned char left_rear_u8;
	unsigned char right_rear_u8;
	unsigned char center_u8;
	unsigned char lfe_u8;
	float volatile distance_f;
	unsigned char distance_u8;
	short room_angle;
	int volatile in_use;
	int volatile channels;
};
struct __anonstruct_buffer_15 {
	void * data;
	int size;
	int left;
};
struct __anonstruct_win32io_14 {
	int append;
	void * h;
	struct __anonstruct_buffer_15 buffer;
};
struct __anonstruct_stdio_16 {
	int autoclose;
	struct _iobuf * fp;
};
struct __anonstruct_mem_17 {
	unsigned char * base;
	unsigned char * here;
	unsigned char * stop;
};
struct __anonstruct_unknown_18 {
	void * data1;
};
union __anonunion_hidden_13 {
	struct __anonstruct_win32io_14 win32io;
	struct __anonstruct_stdio_16 stdio;
	struct __anonstruct_mem_17 mem;
	struct __anonstruct_unknown_18 unknown;
};
struct vocstuff {
	unsigned int rest;
	unsigned int rate;
	int silent;
	unsigned int srate;
	unsigned int blockseek;
	unsigned int samples;
	unsigned int size;
	unsigned char channels;
	int has_extended;
};
struct Mix_Chunk {
	int allocated;
	unsigned char * abuf;
	unsigned int alen;
	unsigned char volume;
};
struct _Mix_effectinfo {
	void( * callback)(int chan, void * stream, int len, void * udata);
	void( * done_callback)(int chan, void * udata);
	void * udata;
	struct _Mix_effectinfo * next;
};
struct _Mix_Channel {
	struct Mix_Chunk * chunk;
	int playing;
	int paused;
	unsigned char * samples;
	int volume;
	int looping;
	int tag;
	unsigned int expire;
	unsigned int start_time;
	unsigned int fading;
	int fade_volume;
	int fade_volume_reset;
	unsigned int fade_length;
	unsigned int ticks_fade;
	struct _Mix_effectinfo * effects;
};
struct __anonstruct_WAVStream_42 {
	struct SDL_RWops * rw;
	unsigned int freerw;
	long start;
	long stop;
	struct SDL_AudioCVT cvt;
};
struct __anonstruct_smpeg_loader_53 {
	int loaded;
	void * handle;
	void( * SMPEG_actualSpec)(void * mpeg, struct SDL_AudioSpec * spec);
	void( * SMPEG_delete)(void * mpeg);
	void( * SMPEG_enableaudio)(void * mpeg, int enable);
	void( * SMPEG_enablevideo)(void * mpeg, int enable);
	void *( * SMPEG_new_rwops)(struct SDL_RWops * src, struct _SMPEG_Info * info, int sdl_audio);
	void( * SMPEG_play)(void * mpeg);
	int( * SMPEG_playAudio)(void * mpeg, unsigned char * stream, int len);
	void( * SMPEG_rewind)(void * mpeg);
	void( * SMPEG_setvolume)(void * mpeg, int volume);
	void( * SMPEG_skip)(void * mpeg, float seconds);
	int( * SMPEG_status)(void * mpeg);
	void( * SMPEG_stop)(void * mpeg);
};
union __anonunion_data_54 {
	WAVStream * wave;
	void * mp3;
};
struct _Mix_Music {
	unsigned int type;
	union __anonunion_data_54 data;
	unsigned int fading;
	int fade_step;
	int fade_steps;
	int error;
};
struct WaveFMT {
	unsigned short encoding;
	unsigned short channels;
	unsigned int frequency;
	unsigned int byterate;
	unsigned short blockalign;
	unsigned short bitspersample;
};
struct Chunk {
	unsigned int magic;
	unsigned int length;
	unsigned char * data;
};

#endif
