class
	SD_IOBUF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_ptr: CE_POINTER [INTEGER_8]
				a_cnt: INTEGER_32
				a_base: CE_POINTER [INTEGER_8]
				a_flag: INTEGER_32
				a_file: INTEGER_32
				a_charbuf: INTEGER_32
				a_bufsiz: INTEGER_32
				a_tmpfname: CE_POINTER [INTEGER_8]
			])
		require else
			a_data /= Void
		do
			make
			Current.ptr := a_data.a_ptr
			Current.cnt := a_data.a_cnt
			Current.base := a_data.a_base
			Current.flag := a_data.a_flag
			Current.file := a_data.a_file
			Current.charbuf := a_data.a_charbuf
			Current.bufsiz := a_data.a_bufsiz
			Current.tmpfname := a_data.a_tmpfname
		end

feature {ANY} -- fields

	ptr: CE_POINTER [INTEGER_8] assign set_ptr
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__ptr (internal_c_pointer))
		end

	cnt: INTEGER_32 assign set_cnt
		do
			Result := c__cnt (internal_c_pointer)
		end

	base: CE_POINTER [INTEGER_8] assign set_base
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__base (internal_c_pointer))
		end

	flag: INTEGER_32 assign set_flag
		do
			Result := c__flag (internal_c_pointer)
		end

	file: INTEGER_32 assign set_file
		do
			Result := c__file (internal_c_pointer)
		end

	charbuf: INTEGER_32 assign set_charbuf
		do
			Result := c__charbuf (internal_c_pointer)
		end

	bufsiz: INTEGER_32 assign set_bufsiz
		do
			Result := c__bufsiz (internal_c_pointer)
		end

	tmpfname: CE_POINTER [INTEGER_8] assign set_tmpfname
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__tmpfname (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_ptr (a_ptr: CE_POINTER [INTEGER_8])
		do
			c__set_ptr (internal_c_pointer, a_ptr.c_pointer)
		end

	set_cnt (a_cnt: INTEGER_32)
		do
			c__set_cnt (internal_c_pointer, a_cnt)
		end

	set_base (a_base: CE_POINTER [INTEGER_8])
		do
			c__set_base (internal_c_pointer, a_base.c_pointer)
		end

	set_flag (a_flag: INTEGER_32)
		do
			c__set_flag (internal_c_pointer, a_flag)
		end

	set_file (a_file: INTEGER_32)
		do
			c__set_file (internal_c_pointer, a_file)
		end

	set_charbuf (a_charbuf: INTEGER_32)
		do
			c__set_charbuf (internal_c_pointer, a_charbuf)
		end

	set_bufsiz (a_bufsiz: INTEGER_32)
		do
			c__set_bufsiz (internal_c_pointer, a_bufsiz)
		end

	set_tmpfname (a_tmpfname: CE_POINTER [INTEGER_8])
		do
			c__set_tmpfname (internal_c_pointer, a_tmpfname.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct _iobuf);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct _iobuf);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__ptr (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _iobuf *)$a_c_pointer)->_ptr;"
		end

	c__cnt (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _iobuf *)$a_c_pointer)->_cnt;"
		end

	c__base (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _iobuf *)$a_c_pointer)->_base;"
		end

	c__flag (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _iobuf *)$a_c_pointer)->_flag;"
		end

	c__file (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _iobuf *)$a_c_pointer)->_file;"
		end

	c__charbuf (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _iobuf *)$a_c_pointer)->_charbuf;"
		end

	c__bufsiz (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _iobuf *)$a_c_pointer)->_bufsiz;"
		end

	c__tmpfname (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _iobuf *)$a_c_pointer)->_tmpfname;"
		end

	c__set_ptr (a_c_pointer: POINTER; a_ptr: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_ptr = $a_ptr;"
		end

	c__set_cnt (a_c_pointer: POINTER; a_cnt: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_cnt = $a_cnt;"
		end

	c__set_base (a_c_pointer: POINTER; a_base: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_base = $a_base;"
		end

	c__set_flag (a_c_pointer: POINTER; a_flag: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_flag = $a_flag;"
		end

	c__set_file (a_c_pointer: POINTER; a_file: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_file = $a_file;"
		end

	c__set_charbuf (a_c_pointer: POINTER; a_charbuf: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_charbuf = $a_charbuf;"
		end

	c__set_bufsiz (a_c_pointer: POINTER; a_bufsiz: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_bufsiz = $a_bufsiz;"
		end

	c__set_tmpfname (a_c_pointer: POINTER; a_tmpfname: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _iobuf *)$a_c_pointer)->_tmpfname = $a_tmpfname;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "ptr") == 0) return offsetof(struct _iobuf, _ptr);
				if(strcmp($a_field_name, "cnt") == 0) return offsetof(struct _iobuf, _cnt);
				if(strcmp($a_field_name, "base") == 0) return offsetof(struct _iobuf, _base);
				if(strcmp($a_field_name, "flag") == 0) return offsetof(struct _iobuf, _flag);
				if(strcmp($a_field_name, "file") == 0) return offsetof(struct _iobuf, _file);
				if(strcmp($a_field_name, "charbuf") == 0) return offsetof(struct _iobuf, _charbuf);
				if(strcmp($a_field_name, "bufsiz") == 0) return offsetof(struct _iobuf, _bufsiz);
				if(strcmp($a_field_name, "tmpfname") == 0) return offsetof(struct _iobuf, _tmpfname);
				fprintf(stderr, "struct _iobuf.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
