class
	SD_SDL_AUDIOCVT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_needed: INTEGER_32
				a_src_format: NATURAL_16
				a_dst_format: NATURAL_16
				a_rate_incr: REAL_64
				a_buf: CE_POINTER [NATURAL_8]
				a_len: INTEGER_32
				a_len_cvt: INTEGER_32
				a_len_mult: INTEGER_32
				a_len_ratio: REAL_64
				a_filters: CE_ARRAY [CE_ROUTINE]
				a_filter_index: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.needed := a_data.a_needed
			Current.src_format := a_data.a_src_format
			Current.dst_format := a_data.a_dst_format
			Current.rate_incr := a_data.a_rate_incr
			Current.buf := a_data.a_buf
			Current.len := a_data.a_len
			Current.len_cvt := a_data.a_len_cvt
			Current.len_mult := a_data.a_len_mult
			Current.len_ratio := a_data.a_len_ratio
			filters.c_pointer.memory_copy (a_data.a_filters.c_pointer, a_data.a_filters.total_count * a_data.a_filters.element_size)
			Current.filter_index := a_data.a_filter_index
		end

feature {ANY} -- fields

	needed: INTEGER_32 assign set_needed
		do
			Result := c__needed (internal_c_pointer)
		end

	src_format: NATURAL_16 assign set_src_format
		do
			Result := c__src_format (internal_c_pointer)
		end

	dst_format: NATURAL_16 assign set_dst_format
		do
			Result := c__dst_format (internal_c_pointer)
		end

	rate_incr: REAL_64 assign set_rate_incr
		do
			Result := c__rate_incr (internal_c_pointer)
		end

	buf: CE_POINTER [NATURAL_8] assign set_buf
		do
			create {CE_NATURAL_8_POINTER} Result.make_shared (c__buf (internal_c_pointer))
		end

	len: INTEGER_32 assign set_len
		do
			Result := c__len (internal_c_pointer)
		end

	len_cvt: INTEGER_32 assign set_len_cvt
		do
			Result := c__len_cvt (internal_c_pointer)
		end

	len_mult: INTEGER_32 assign set_len_mult
		do
			Result := c__len_mult (internal_c_pointer)
		end

	len_ratio: REAL_64 assign set_len_ratio
		do
			Result := c__len_ratio (internal_c_pointer)
		end

	filters: CE_ARRAY [CE_ROUTINE]
		once ("OBJECT")
			create {CE_ROUTINE_ARRAY} Result.make_shared (c__filters (internal_c_pointer), <<10>>)
		end

	filter_index: INTEGER_32 assign set_filter_index
		do
			Result := c__filter_index (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_needed (a_needed: INTEGER_32)
		do
			c__set_needed (internal_c_pointer, a_needed)
		end

	set_src_format (a_src_format: NATURAL_16)
		do
			c__set_src_format (internal_c_pointer, a_src_format)
		end

	set_dst_format (a_dst_format: NATURAL_16)
		do
			c__set_dst_format (internal_c_pointer, a_dst_format)
		end

	set_rate_incr (a_rate_incr: REAL_64)
		do
			c__set_rate_incr (internal_c_pointer, a_rate_incr)
		end

	set_buf (a_buf: CE_POINTER [NATURAL_8])
		do
			c__set_buf (internal_c_pointer, a_buf.c_pointer)
		end

	set_len (a_len: INTEGER_32)
		do
			c__set_len (internal_c_pointer, a_len)
		end

	set_len_cvt (a_len_cvt: INTEGER_32)
		do
			c__set_len_cvt (internal_c_pointer, a_len_cvt)
		end

	set_len_mult (a_len_mult: INTEGER_32)
		do
			c__set_len_mult (internal_c_pointer, a_len_mult)
		end

	set_len_ratio (a_len_ratio: REAL_64)
		do
			c__set_len_ratio (internal_c_pointer, a_len_ratio)
		end

	set_filter_index (a_filter_index: INTEGER_32)
		do
			c__set_filter_index (internal_c_pointer, a_filter_index)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct SDL_AudioCVT);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct SDL_AudioCVT);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__needed (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->needed;"
		end

	c__src_format (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->src_format;"
		end

	c__dst_format (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->dst_format;"
		end

	c__rate_incr (a_c_pointer: POINTER): REAL_64
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->rate_incr;"
		end

	c__buf (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_AudioCVT *)$a_c_pointer)->buf;"
		end

	c__len (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->len;"
		end

	c__len_cvt (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->len_cvt;"
		end

	c__len_mult (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->len_mult;"
		end

	c__len_ratio (a_c_pointer: POINTER): REAL_64
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->len_ratio;"
		end

	c__filters (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_AudioCVT *)$a_c_pointer)->filters;"
		end

	c__filter_index (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioCVT *)$a_c_pointer)->filter_index;"
		end

	c__set_needed (a_c_pointer: POINTER; a_needed: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->needed = $a_needed;"
		end

	c__set_src_format (a_c_pointer: POINTER; a_src_format: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->src_format = $a_src_format;"
		end

	c__set_dst_format (a_c_pointer: POINTER; a_dst_format: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->dst_format = $a_dst_format;"
		end

	c__set_rate_incr (a_c_pointer: POINTER; a_rate_incr: REAL_64)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->rate_incr = $a_rate_incr;"
		end

	c__set_buf (a_c_pointer: POINTER; a_buf: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->buf = $a_buf;"
		end

	c__set_len (a_c_pointer: POINTER; a_len: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->len = $a_len;"
		end

	c__set_len_cvt (a_c_pointer: POINTER; a_len_cvt: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->len_cvt = $a_len_cvt;"
		end

	c__set_len_mult (a_c_pointer: POINTER; a_len_mult: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->len_mult = $a_len_mult;"
		end

	c__set_len_ratio (a_c_pointer: POINTER; a_len_ratio: REAL_64)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->len_ratio = $a_len_ratio;"
		end

	c__set_filter_index (a_c_pointer: POINTER; a_filter_index: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioCVT *)$a_c_pointer)->filter_index = $a_filter_index;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "needed") == 0) return offsetof(struct SDL_AudioCVT, needed);
				if(strcmp($a_field_name, "src_format") == 0) return offsetof(struct SDL_AudioCVT, src_format);
				if(strcmp($a_field_name, "dst_format") == 0) return offsetof(struct SDL_AudioCVT, dst_format);
				if(strcmp($a_field_name, "rate_incr") == 0) return offsetof(struct SDL_AudioCVT, rate_incr);
				if(strcmp($a_field_name, "buf") == 0) return offsetof(struct SDL_AudioCVT, buf);
				if(strcmp($a_field_name, "len") == 0) return offsetof(struct SDL_AudioCVT, len);
				if(strcmp($a_field_name, "len_cvt") == 0) return offsetof(struct SDL_AudioCVT, len_cvt);
				if(strcmp($a_field_name, "len_mult") == 0) return offsetof(struct SDL_AudioCVT, len_mult);
				if(strcmp($a_field_name, "len_ratio") == 0) return offsetof(struct SDL_AudioCVT, len_ratio);
				if(strcmp($a_field_name, "filters") == 0) return offsetof(struct SDL_AudioCVT, filters);
				if(strcmp($a_field_name, "filter_index") == 0) return offsetof(struct SDL_AudioCVT, filter_index);
				fprintf(stderr, "struct SDL_AudioCVT.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
