class
	SD_SDL_AUDIOSPEC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_freq: INTEGER_32
				a_format: NATURAL_16
				a_channels: NATURAL_8
				a_silence: NATURAL_8
				a_samples: NATURAL_16
				a_padding: NATURAL_16
				a_size: NATURAL_32
				a_callback: CE_ROUTINE
				a_userdata: CE_POINTER [ANY]
			])
		require else
			a_data /= Void
		do
			make
			Current.freq := a_data.a_freq
			Current.format := a_data.a_format
			Current.channels := a_data.a_channels
			Current.silence := a_data.a_silence
			Current.samples := a_data.a_samples
			Current.padding := a_data.a_padding
			Current.size := a_data.a_size
			Current.callback := a_data.a_callback
			Current.userdata := a_data.a_userdata
		end

feature {ANY} -- fields

	freq: INTEGER_32 assign set_freq
		do
			Result := c__freq (internal_c_pointer)
		end

	format: NATURAL_16 assign set_format
		do
			Result := c__format (internal_c_pointer)
		end

	channels: NATURAL_8 assign set_channels
		do
			Result := c__channels (internal_c_pointer)
		end

	silence: NATURAL_8 assign set_silence
		do
			Result := c__silence (internal_c_pointer)
		end

	samples: NATURAL_16 assign set_samples
		do
			Result := c__samples (internal_c_pointer)
		end

	padding: NATURAL_16 assign set_padding
		do
			Result := c__padding (internal_c_pointer)
		end

	size: NATURAL_32 assign set_size
		do
			Result := c__size (internal_c_pointer)
		end

	callback: CE_ROUTINE assign set_callback
		do
			create Result.make_shared (c__callback (internal_c_pointer))
		end

	userdata: CE_POINTER [ANY] assign set_userdata
		do
			create {CE_VOID_POINTER} Result.make_shared (c__userdata (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_freq (a_freq: INTEGER_32)
		do
			c__set_freq (internal_c_pointer, a_freq)
		end

	set_format (a_format: NATURAL_16)
		do
			c__set_format (internal_c_pointer, a_format)
		end

	set_channels (a_channels: NATURAL_8)
		do
			c__set_channels (internal_c_pointer, a_channels)
		end

	set_silence (a_silence: NATURAL_8)
		do
			c__set_silence (internal_c_pointer, a_silence)
		end

	set_samples (a_samples: NATURAL_16)
		do
			c__set_samples (internal_c_pointer, a_samples)
		end

	set_padding (a_padding: NATURAL_16)
		do
			c__set_padding (internal_c_pointer, a_padding)
		end

	set_size (a_size: NATURAL_32)
		do
			c__set_size (internal_c_pointer, a_size)
		end

	set_callback (a_callback: CE_ROUTINE)
		do
			c__set_callback (internal_c_pointer, a_callback.c_pointer)
		end

	set_userdata (a_userdata: CE_POINTER [ANY])
		do
			c__set_userdata (internal_c_pointer, a_userdata.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct SDL_AudioSpec);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct SDL_AudioSpec);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__freq (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioSpec *)$a_c_pointer)->freq;"
		end

	c__format (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioSpec *)$a_c_pointer)->format;"
		end

	c__channels (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioSpec *)$a_c_pointer)->channels;"
		end

	c__silence (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioSpec *)$a_c_pointer)->silence;"
		end

	c__samples (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioSpec *)$a_c_pointer)->samples;"
		end

	c__padding (a_c_pointer: POINTER): NATURAL_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioSpec *)$a_c_pointer)->padding;"
		end

	c__size (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_AudioSpec *)$a_c_pointer)->size;"
		end

	c__callback (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_AudioSpec *)$a_c_pointer)->callback;"
		end

	c__userdata (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct SDL_AudioSpec *)$a_c_pointer)->userdata;"
		end

	c__set_freq (a_c_pointer: POINTER; a_freq: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->freq = $a_freq;"
		end

	c__set_format (a_c_pointer: POINTER; a_format: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->format = $a_format;"
		end

	c__set_channels (a_c_pointer: POINTER; a_channels: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->channels = $a_channels;"
		end

	c__set_silence (a_c_pointer: POINTER; a_silence: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->silence = $a_silence;"
		end

	c__set_samples (a_c_pointer: POINTER; a_samples: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->samples = $a_samples;"
		end

	c__set_padding (a_c_pointer: POINTER; a_padding: NATURAL_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->padding = $a_padding;"
		end

	c__set_size (a_c_pointer: POINTER; a_size: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->size = $a_size;"
		end

	c__set_callback (a_c_pointer: POINTER; a_callback: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->callback = $a_callback;"
		end

	c__set_userdata (a_c_pointer: POINTER; a_userdata: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_AudioSpec *)$a_c_pointer)->userdata = $a_userdata;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "freq") == 0) return offsetof(struct SDL_AudioSpec, freq);
				if(strcmp($a_field_name, "format") == 0) return offsetof(struct SDL_AudioSpec, format);
				if(strcmp($a_field_name, "channels") == 0) return offsetof(struct SDL_AudioSpec, channels);
				if(strcmp($a_field_name, "silence") == 0) return offsetof(struct SDL_AudioSpec, silence);
				if(strcmp($a_field_name, "samples") == 0) return offsetof(struct SDL_AudioSpec, samples);
				if(strcmp($a_field_name, "padding") == 0) return offsetof(struct SDL_AudioSpec, padding);
				if(strcmp($a_field_name, "size") == 0) return offsetof(struct SDL_AudioSpec, size);
				if(strcmp($a_field_name, "callback") == 0) return offsetof(struct SDL_AudioSpec, callback);
				if(strcmp($a_field_name, "userdata") == 0) return offsetof(struct SDL_AudioSpec, userdata);
				fprintf(stderr, "struct SDL_AudioSpec.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
