class
	SD_SDL_VERSION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_major: NATURAL_8
				a_minor: NATURAL_8
				a_patch: NATURAL_8
			])
		require else
			a_data /= Void
		do
			make
			Current.major := a_data.a_major
			Current.minor := a_data.a_minor
			Current.patch := a_data.a_patch
		end

feature {ANY} -- fields

	major: NATURAL_8 assign set_major
		do
			Result := c__major (internal_c_pointer)
		end

	minor: NATURAL_8 assign set_minor
		do
			Result := c__minor (internal_c_pointer)
		end

	patch: NATURAL_8 assign set_patch
		do
			Result := c__patch (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_major (a_major: NATURAL_8)
		do
			c__set_major (internal_c_pointer, a_major)
		end

	set_minor (a_minor: NATURAL_8)
		do
			c__set_minor (internal_c_pointer, a_minor)
		end

	set_patch (a_patch: NATURAL_8)
		do
			c__set_patch (internal_c_pointer, a_patch)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct SDL_version);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct SDL_version);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__major (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_version *)$a_c_pointer)->major;"
		end

	c__minor (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_version *)$a_c_pointer)->minor;"
		end

	c__patch (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct SDL_version *)$a_c_pointer)->patch;"
		end

	c__set_major (a_c_pointer: POINTER; a_major: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_version *)$a_c_pointer)->major = $a_major;"
		end

	c__set_minor (a_c_pointer: POINTER; a_minor: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_version *)$a_c_pointer)->minor = $a_minor;"
		end

	c__set_patch (a_c_pointer: POINTER; a_patch: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct SDL_version *)$a_c_pointer)->patch = $a_patch;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "major") == 0) return offsetof(struct SDL_version, major);
				if(strcmp($a_field_name, "minor") == 0) return offsetof(struct SDL_version, minor);
				if(strcmp($a_field_name, "patch") == 0) return offsetof(struct SDL_version, patch);
				fprintf(stderr, "struct SDL_version.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
