class
	SD_SMPEG_INFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_has_audio: INTEGER_32
				a_has_video: INTEGER_32
				a_width: INTEGER_32
				a_height: INTEGER_32
				a_current_frame: INTEGER_32
				a_current_fps: REAL_64
				a_audio_string: CE_ARRAY [INTEGER_8]
				a_audio_current_frame: INTEGER_32
				a_current_offset: NATURAL_32
				a_total_size: NATURAL_32
				a_current_time: REAL_64
				a_total_time: REAL_64
			])
		require else
			a_data /= Void
		do
			make
			Current.has_audio := a_data.a_has_audio
			Current.has_video := a_data.a_has_video
			Current.width := a_data.a_width
			Current.height := a_data.a_height
			Current.current_frame := a_data.a_current_frame
			Current.current_fps := a_data.a_current_fps
			audio_string.c_pointer.memory_copy (a_data.a_audio_string.c_pointer, a_data.a_audio_string.total_count * a_data.a_audio_string.element_size)
			Current.audio_current_frame := a_data.a_audio_current_frame
			Current.current_offset := a_data.a_current_offset
			Current.total_size := a_data.a_total_size
			Current.current_time := a_data.a_current_time
			Current.total_time := a_data.a_total_time
		end

feature {ANY} -- fields

	has_audio: INTEGER_32 assign set_has_audio
		do
			Result := c__has_audio (internal_c_pointer)
		end

	has_video: INTEGER_32 assign set_has_video
		do
			Result := c__has_video (internal_c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c__width (internal_c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c__height (internal_c_pointer)
		end

	current_frame: INTEGER_32 assign set_current_frame
		do
			Result := c__current_frame (internal_c_pointer)
		end

	current_fps: REAL_64 assign set_current_fps
		do
			Result := c__current_fps (internal_c_pointer)
		end

	audio_string: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__audio_string (internal_c_pointer), <<80>>)
		end

	audio_current_frame: INTEGER_32 assign set_audio_current_frame
		do
			Result := c__audio_current_frame (internal_c_pointer)
		end

	current_offset: NATURAL_32 assign set_current_offset
		do
			Result := c__current_offset (internal_c_pointer)
		end

	total_size: NATURAL_32 assign set_total_size
		do
			Result := c__total_size (internal_c_pointer)
		end

	current_time: REAL_64 assign set_current_time
		do
			Result := c__current_time (internal_c_pointer)
		end

	total_time: REAL_64 assign set_total_time
		do
			Result := c__total_time (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_has_audio (a_has_audio: INTEGER_32)
		do
			c__set_has_audio (internal_c_pointer, a_has_audio)
		end

	set_has_video (a_has_video: INTEGER_32)
		do
			c__set_has_video (internal_c_pointer, a_has_video)
		end

	set_width (a_width: INTEGER_32)
		do
			c__set_width (internal_c_pointer, a_width)
		end

	set_height (a_height: INTEGER_32)
		do
			c__set_height (internal_c_pointer, a_height)
		end

	set_current_frame (a_current_frame: INTEGER_32)
		do
			c__set_current_frame (internal_c_pointer, a_current_frame)
		end

	set_current_fps (a_current_fps: REAL_64)
		do
			c__set_current_fps (internal_c_pointer, a_current_fps)
		end

	set_audio_current_frame (a_audio_current_frame: INTEGER_32)
		do
			c__set_audio_current_frame (internal_c_pointer, a_audio_current_frame)
		end

	set_current_offset (a_current_offset: NATURAL_32)
		do
			c__set_current_offset (internal_c_pointer, a_current_offset)
		end

	set_total_size (a_total_size: NATURAL_32)
		do
			c__set_total_size (internal_c_pointer, a_total_size)
		end

	set_current_time (a_current_time: REAL_64)
		do
			c__set_current_time (internal_c_pointer, a_current_time)
		end

	set_total_time (a_total_time: REAL_64)
		do
			c__set_total_time (internal_c_pointer, a_total_time)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct _SMPEG_Info);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct _SMPEG_Info);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__has_audio (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->has_audio;"
		end

	c__has_video (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->has_video;"
		end

	c__width (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->width;"
		end

	c__height (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->height;"
		end

	c__current_frame (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->current_frame;"
		end

	c__current_fps (a_c_pointer: POINTER): REAL_64
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->current_fps;"
		end

	c__audio_string (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _SMPEG_Info *)$a_c_pointer)->audio_string;"
		end

	c__audio_current_frame (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->audio_current_frame;"
		end

	c__current_offset (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->current_offset;"
		end

	c__total_size (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->total_size;"
		end

	c__current_time (a_c_pointer: POINTER): REAL_64
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->current_time;"
		end

	c__total_time (a_c_pointer: POINTER): REAL_64
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _SMPEG_Info *)$a_c_pointer)->total_time;"
		end

	c__set_has_audio (a_c_pointer: POINTER; a_has_audio: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->has_audio = $a_has_audio;"
		end

	c__set_has_video (a_c_pointer: POINTER; a_has_video: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->has_video = $a_has_video;"
		end

	c__set_width (a_c_pointer: POINTER; a_width: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->width = $a_width;"
		end

	c__set_height (a_c_pointer: POINTER; a_height: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->height = $a_height;"
		end

	c__set_current_frame (a_c_pointer: POINTER; a_current_frame: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->current_frame = $a_current_frame;"
		end

	c__set_current_fps (a_c_pointer: POINTER; a_current_fps: REAL_64)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->current_fps = $a_current_fps;"
		end

	c__set_audio_current_frame (a_c_pointer: POINTER; a_audio_current_frame: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->audio_current_frame = $a_audio_current_frame;"
		end

	c__set_current_offset (a_c_pointer: POINTER; a_current_offset: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->current_offset = $a_current_offset;"
		end

	c__set_total_size (a_c_pointer: POINTER; a_total_size: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->total_size = $a_total_size;"
		end

	c__set_current_time (a_c_pointer: POINTER; a_current_time: REAL_64)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->current_time = $a_current_time;"
		end

	c__set_total_time (a_c_pointer: POINTER; a_total_time: REAL_64)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _SMPEG_Info *)$a_c_pointer)->total_time = $a_total_time;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "has_audio") == 0) return offsetof(struct _SMPEG_Info, has_audio);
				if(strcmp($a_field_name, "has_video") == 0) return offsetof(struct _SMPEG_Info, has_video);
				if(strcmp($a_field_name, "width") == 0) return offsetof(struct _SMPEG_Info, width);
				if(strcmp($a_field_name, "height") == 0) return offsetof(struct _SMPEG_Info, height);
				if(strcmp($a_field_name, "current_frame") == 0) return offsetof(struct _SMPEG_Info, current_frame);
				if(strcmp($a_field_name, "current_fps") == 0) return offsetof(struct _SMPEG_Info, current_fps);
				if(strcmp($a_field_name, "audio_string") == 0) return offsetof(struct _SMPEG_Info, audio_string);
				if(strcmp($a_field_name, "audio_current_frame") == 0) return offsetof(struct _SMPEG_Info, audio_current_frame);
				if(strcmp($a_field_name, "current_offset") == 0) return offsetof(struct _SMPEG_Info, current_offset);
				if(strcmp($a_field_name, "total_size") == 0) return offsetof(struct _SMPEG_Info, total_size);
				if(strcmp($a_field_name, "current_time") == 0) return offsetof(struct _SMPEG_Info, current_time);
				if(strcmp($a_field_name, "total_time") == 0) return offsetof(struct _SMPEG_Info, total_time);
				fprintf(stderr, "struct _SMPEG_Info.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
