class
	SD_WIN32IO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_append: INTEGER_32
				a_h: CE_POINTER [ANY]
				a_buffer: SD_BUFFER
			])
		require else
			a_data /= Void
		do
			make
			Current.append := a_data.a_append
			Current.h := a_data.a_h
			buffer.c_pointer.memory_copy (a_data.a_buffer.c_pointer, a_data.a_buffer.structure_size)
		end

feature {ANY} -- fields

	append: INTEGER_32 assign set_append
		do
			Result := c__append (internal_c_pointer)
		end

	h: CE_POINTER [ANY] assign set_h
		do
			create {CE_VOID_POINTER} Result.make_shared (c__h (internal_c_pointer))
		end

	buffer: SD_BUFFER
		once ("OBJECT")
			create Result.make_shared (c__buffer (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_append (a_append: INTEGER_32)
		do
			c__set_append (internal_c_pointer, a_append)
		end

	set_h (a_h: CE_POINTER [ANY])
		do
			c__set_h (internal_c_pointer, a_h.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct __anonstruct_win32io_14);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct __anonstruct_win32io_14);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__append (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_win32io_14 *)$a_c_pointer)->append;"
		end

	c__h (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_win32io_14 *)$a_c_pointer)->h;"
		end

	c__buffer (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct_win32io_14 *)$a_c_pointer)->buffer;"
		end

	c__set_append (a_c_pointer: POINTER; a_append: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_win32io_14 *)$a_c_pointer)->append = $a_append;"
		end

	c__set_h (a_c_pointer: POINTER; a_h: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_win32io_14 *)$a_c_pointer)->h = $a_h;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "append") == 0) return offsetof(struct __anonstruct_win32io_14, append);
				if(strcmp($a_field_name, "h") == 0) return offsetof(struct __anonstruct_win32io_14, h);
				if(strcmp($a_field_name, "buffer") == 0) return offsetof(struct __anonstruct_win32io_14, buffer);
				fprintf(stderr, "struct __anonstruct_win32io_14.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
